// inludes
#include "/usr/local/include/fox/fx.h"
#include "ClassDialog.h"
#include "icons.h"
#include "vars.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Map
FXDEFMAP(ClassDialog) ClassDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_CLASS_NAME,ClassDialog::onCmdClassName),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_RESULTS,ClassDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_VARS,ClassDialog::onCmdVars),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_ADD_VAR,ClassDialog::onCmdAddVar),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_CLEAR_VARS,ClassDialog::onCmdClearVars),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_REMOVE_VAR,ClassDialog::onCmdRemoveVar),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_ENUMS,ClassDialog::onCmdEnums),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_ADD_ENUM,ClassDialog::onCmdAddEnum),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_REMOVE_ENUM,ClassDialog::onCmdRemoveEnum),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_METHODS,ClassDialog::onCmdMethods),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_ADD_METHOD,ClassDialog::onCmdAddMethod),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_REMOVE_METHOD,ClassDialog::onCmdRemoveMethod),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_VAR_TYPE,ClassDialog::onCmdVarType),
  FXMAPFUNC(SEL_COMMAND,ClassDialog::ID_CLASS_TYPE,ClassDialog::onCmdClassType),
};


// ButtonApp implementation
FXIMPLEMENT(ClassDialog,FXDialogBox,ClassDialogMap,ARRAYNUMBER(ClassDialogMap))

// Make some windows
ClassDialog::ClassDialog(FXWindow* owner):FXDialogBox(owner,"Main Application",DECOR_TITLE|DECOR_BORDER,0)
{
  mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
              buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	
	FXTabBook* MainTabs=new FXTabBook(this,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_RIGHT);
	tab1=new FXTabItem(MainTabs,"&Basics",NULL);
		 FXMatrix* mtxBasics=new FXMatrix(MainTabs,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);

		 FXLabel *lblClass=new FXLabel(mtxBasics,"&Class name:\tApplication class name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		 lblClass->setFont(mainFont);
		 txtClassName=new FXTextField(mtxBasics,15,this,ID_CLASS_NAME,LAYOUT_LEFT|FRAME_SUNKEN|JUSTIFY_LEFT);
		 txtClassName->setFont(mainFont);
	
		 FXLabel *lblClassType=new FXLabel(mtxBasics,"&Base Class:\tParent class name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		 lblClassType->setFont(mainFont);
		 lstClassTypes=new FXList(mtxBasics,20,this,ID_CLASS_TYPE,LISTBOX_NORMAL|FRAME_SUNKEN|LAYOUT_FILL_X);
		 lstClassTypes->setFont(mainFont);
		 for (int i=0; i<21; i++) lstClassTypes->appendItem(VarTypesStr[i]);
		 lstClassTypes->setCurrentItem(0);
  	
  	  tab2=new FXTabItem(MainTabs,"&Variables",NULL);
  	  	FXMatrix* mtxVars=new FXMatrix(MainTabs,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		lstVarTypes=new FXList(mtxVars,10,this,ID_VAR_TYPE,LISTBOX_NORMAL|FRAME_SUNKEN|LAYOUT_FILL_X);
		lstVarTypes->setFont(mainFont);
		for (int i=0; i<21; i++) lstVarTypes->appendItem(VarTypesStr[i]);
		lstVarTypes->setCurrentItem(0);
		txtAddVar=new FXTextField(mtxVars,15,this,ID_ADD_VAR,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		txtAddVar->setFont(mainFont);
		lstVars=new FXList(mtxVars,10,this,ID_VARS,LISTBOX_NORMAL|LAYOUT_FILL_X);
		lstVars->appendItem("FXTextField* Test");
		lstVars->setFont(mainFont);
		
		FXHorizontalFrame* hfrmOptions=new FXHorizontalFrame(mtxVars,LAYOUT_NORMAL|FRAME_RAISED,1,1,100,50);
		   FXButton* btnRemoveVar=new FXButton(hfrmOptions,"\tRemove line from var list",deleteicon,this,ID_REMOVE_VAR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
		   btnRemoveVar->setFont(mainFont);
		   //Clear
		   FXButton* btnClear=new FXButton(hfrmOptions,"Clear\tClear the list",NULL,this,ID_CLEAR_VARS,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnClear->setFont(mainFont);		
		
	tab3=new FXTabItem(MainTabs,"&Enumerations",NULL);
		FXMatrix* mtxEnums=new FXMatrix(MainTabs,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		FXLabel* lblAddEnum=new FXLabel(mtxEnums,"Add Enum\tAdd New Enum",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,126,25);
		lblAddEnum->setFont(mainFont);
		txtAddEnum=new FXTextField(mtxEnums,20,this,ID_ADD_ENUM,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		txtAddEnum->setFont(mainFont);
		lstEnums=new FXList(mtxEnums,10,this,ID_ENUMS,LISTBOX_NORMAL|LAYOUT_FILL_X);
		lstEnums->appendItem("ID_NEW");
		lstEnums->setFont(mainFont);
		FXButton* btnRemoveEnum=new FXButton(mtxEnums,"\tRemove Line from enum List",deleteicon,this,ID_REMOVE_ENUM,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
		btnRemoveEnum->setFont(mainFont);
	
	tab4=new FXTabItem(MainTabs,"M&ethods",NULL);
		FXMatrix* mtxMethods=new FXMatrix(MainTabs,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);	
		FXLabel* lblAddMethod=new FXLabel(mtxMethods,"Add Method\tAdd New Method",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,126,25);
		lblAddMethod->setFont(mainFont);
		txtAddMethod=new FXTextField(mtxMethods,20,this,ID_ADD_METHOD,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		txtAddMethod->setFont(mainFont);
		lstMethods=new FXList(mtxMethods,10,this,ID_METHODS,LISTBOX_NORMAL|LAYOUT_FILL_X);
		lstMethods->appendItem("onCmd...");
		lstMethods->setFont(mainFont);
		FXButton* btnRemoveMethod=new FXButton(mtxMethods,"\tRemove line from method list",deleteicon,this,ID_REMOVE_METHOD,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
		btnRemoveMethod->setFont(mainFont);

		//     Main
	btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",createicon,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
	btnCancel=new FXButton(buttons,"Close\tClose the Dialog",createicon,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
}

ClassDialog::~ClassDialog(){}

long ClassDialog::onCmdClassName(FXObject*,FXSelector,void*)
{
	return 1;
}

long ClassDialog::onCmdVars(FXObject*,FXSelector,void*)
{
	return 1;
}

long ClassDialog::onCmdAddVar(FXObject*,FXSelector,void*)
{
	lstVars->appendItem(txtAddVar->getText(),NULL);
	txtAddVar->setText("");
	return 1;
}

long ClassDialog::onCmdRemoveVar(FXObject*,FXSelector,void*)
{
	lstVars->removeItem(lstVars->getCurrentItem());
	return 1;
}

long ClassDialog::onCmdClearVars(FXObject*,FXSelector,void*)
{
	  lstVars->clearItems();
	  return 1;
}

long ClassDialog::onCmdEnums(FXObject*,FXSelector,void*)
{
	return 1;
}

long ClassDialog::onCmdAddEnum(FXObject*,FXSelector,void*)
{
	lstEnums->appendItem(txtAddEnum->getText(),NULL);
	txtAddEnum->setText("");
	return 1;
}

long ClassDialog::onCmdRemoveEnum(FXObject*,FXSelector,void*)
{
	lstEnums->removeItem(lstEnums->getCurrentItem());
	return 1;
}

long ClassDialog::onCmdMethods(FXObject*,FXSelector,void*)
{
	return 1;
}

long ClassDialog::onCmdAddMethod(FXObject*,FXSelector,void*)
{
	lstMethods->appendItem(txtAddMethod->getText(),NULL);
	txtAddMethod->setText("");
	return 1;
}

long ClassDialog::onCmdRemoveMethod(FXObject*,FXSelector,void*)
{
	lstMethods->removeItem(lstMethods->getCurrentItem());
	return 1;
}

long ClassDialog::onCmdToolBox(FXObject*,FXSelector,void*)
{
	return 1;
}


long ClassDialog::onCmdToolTip(FXObject*,FXSelector,void*)
{
	return 1;
}

long ClassDialog::onCmdClassType(FXObject*,FXSelector,void*)
{
	return 1;
}

long ClassDialog::onCmdVarType(FXObject*,FXSelector,void*)
{
	txtAddVar->setText(lstVarTypes->getItemText(lstVarTypes->getCurrentItem()));
	return 1;
}

long ClassDialog::onCmdResults(FXObject*,FXSelector,void*)
{             FXString textMain;
	FXString* SumResM;
	FXString stdVarStr;
	FXString ClassStr;
	FXString VarStr;
	FXString EnumStr;
	FXString MethodStr;
	FXString MapStr;
	FXString FirstMapLine;
	FXString ImpStr;
	FXString LastImpStr;
	FXString CreateStr;
	FXString MethodImp;
	FXString strIncludes;
	FXString TotalM;
	
	FXString Cname=txtClassName->getText();
	for (int i=0; i<lstVars->getNumItems(); i++)
		VarStr=VarStr+"\t\t"+lstVars->getItemText(i)+";\n";
	VarStr=stdVarStr+VarStr;	
	EnumStr="\t\t"+lstEnums->getItemText(0)+"=FXMainWindow::ID_LAST,\n";
	for (int i=1; i<lstEnums->getNumItems(); i++)
		EnumStr=EnumStr+"\t\t"+lstEnums->getItemText(i)+",\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MethodStr=MethodStr+"\t\t"+"long "+ lstMethods->getItemText(i)+"(FXObject*,FXSelector,void*);\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MapStr=MapStr+"FXMAPFUNC(SEL_COMMAND,"+Cname+"::"+lstEnums->getItemText(i)+","+Cname+"::"+lstMethods->getItemText(i)+"),\n";
	ClassStr="class "+ Cname+": public "+lstClassTypes->getItemText(lstClassTypes->getCurrentItem())+"\n"+
		"{\n"+"	FXDECLARE("+Cname+")\n"+
		"\tprotected:\n"+
		VarStr+
		"\tprotected:\n"+"\t"+
		Cname+"(){}\n"+
		"\tpublic:\n"+
		"\tenum {\n"+EnumStr+
		"};\n"+
		"\tpublic:\n"+MethodStr+
		"\tpublic:\n\t\t"+Cname+
		"(FXApp* a);\n"+"\t\tvirtual ~"+Cname+"();\n";

	TotalM=strIncludes+ClassStr+"};\n";
	SumResM=&TotalM;
	editor->insertText(editor->getCursorPos(),SumResM->text(),SumResM->size()-1, FALSE);
	return 1;
}
