#include "/usr/local/include/fox/fx.h"
#include "DialDialog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "icons.h"
#include "vars.h"
// Map
FXDEFMAP(DialDialog) DialDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_WIDTH,DialDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_HEIGHT,DialDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_POSX,DialDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_POSY,DialDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_RESULTS,DialDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_TOOLTIP,DialDialog::onCmdToolTip),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_LAYOUT,DialDialog::onCmdLayout),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_TARGET,DialDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_SELECTOR,DialDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_FRAME,DialDialog::onCmdFrame),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_DECLARE,DialDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_COLOR_DECLARE,DialDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_BASE_COLOR,DialDialog::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_BORDER_COLOR,DialDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_HILITE_COLOR,DialDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_SHADOW_COLOR,DialDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_BACK_COLOR,DialDialog::onCmdBackColor),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_NOTCH_COLOR,DialDialog::onCmdNotchColor),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_NOTCH_SPACE,DialDialog::onCmdNotchSpace),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_NOTCH_OFFSET,DialDialog::onCmdNotchOffset),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_REV_INC,DialDialog::onCmdRevInc),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_HELP,DialDialog::onCmdHelp),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_DIRECTION,DialDialog::onCmdDirection),
  FXMAPFUNC(SEL_COMMAND,DialDialog::ID_NAME,DialDialog::onCmdName),
 };

// ButtonApp implementation
FXIMPLEMENT(DialDialog,FXDialogBox,DialDialogMap,ARRAYNUMBER(DialDialogMap))

// Make some windows
DialDialog::DialDialog(FXWindow* owner):FXDialogBox(owner,"Button Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
         	
		//Notch color
		btnNotchColor=new FXButton(mdiTools,"\tNotch color",coloricon,this,ID_NOTCH_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnNotchColor->setFont(mainFont);
		btnNotchColor->setBaseColor(FXRGBA(255,100,0,255));

              	//Basic Color
		btnBaseColor=new FXButton(mdiTools,"\tBase color",coloricon,this,ID_BASE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBaseColor->setFont(mainFont);
		btnBaseColor->setBaseColor(FXRGBA(255,100,0,255));
		
		//HIlite
		btnHiliteColor=new FXButton(mdiTools,"\tHilite color",coloricon,this,ID_HILITE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setHiliteColor(FXRGBA(255,0,0,255));

		//Border color
		btnBorderColor=new FXButton(mdiTools,"\tBorder color",coloricon,this,ID_BORDER_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setBorderColor(FXRGBA(0,255,0,255));

		//Shadow
		btnShadowColor=new FXButton(mdiTools,"\tShadow color",coloricon,this,ID_SHADOW_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setShadowColor(FXRGBA(255,0,0,255));

		//Back Color
		btnBackColor=new FXButton(mdiTools,"\tBack color",coloricon,this,ID_BACK_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setBackColor(FXRGBA(255,0,0,255));

	FXMatrix* controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);		
             	
		//Name
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("dial");
	
		//Owner
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);

		//Tip
		FXLabel *lblTooltip=new FXLabel(controls,"&Tool Tip:\tTip when the mouse is over",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTooltip->setFont(mainFont);
		txtTooltip=new FXTextField(controls,15,this,ID_TOOLTIP,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTooltip->setFont(mainFont);

		//Help
		FXLabel *lblHelp=new FXLabel(controls,"&Help:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblHelp->setFont(mainFont);
		txtHelp=new FXTextField(controls,15,this,ID_HELP,LAYOUT_LEFT|FRAME_SUNKEN);
		txtHelp->setFont(mainFont);
			
		//Target
		FXLabel *lblTarget=new FXLabel(controls,"&Target,ID:\tTarget,ID",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTarget->setFont(mainFont);
		txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTarget->setFont(mainFont);
		
	              //Selector
		FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblSelector->setFont(mainFont);
		txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
		txtSelector->setFont(mainFont);

		//Direction
		FXLabel *lblDir=new FXLabel(controls,"&Direction:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblDir->setFont(mainFont);
		combostyle=new FXComboBox(controls,15,2,this,ID_DIRECTION,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<2; i++){  combostyle->appendItem(strDialStyle[i]);         }
		combostyle->setCurrentItem(0);
		
		//Layout
		FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lbllayout->setFont(mainFont);
		combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
		combolayout->setCurrentItem(0);

		//Frame
		FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblframe->setFont(mainFont);
		comboframe=new FXComboBox(controls,15,5,this,ID_FRAME,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
		comboframe->setCurrentItem(0);

		//Notch Space
		FXLabel* lblSpace=new FXLabel(controls,"&Notch Space:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblSpace->setFont(mainFont);
		spinNotchSpace=new FXSpinner(controls,6,this,ID_NOTCH_SPACE,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinNotchSpace->setFont(mainFont);
		spinNotchSpace->setRange(1,3600);
		
		//Notch Offset
		FXLabel* lblOffset=new FXLabel(controls,"&Notch Offset:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblOffset->setFont(mainFont);
		spinNotchOffset=new FXSpinner(controls,6,this,ID_NOTCH_OFFSET,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinNotchOffset->setFont(mainFont);
		spinNotchOffset->setRange(-3600,3600);
		
		//Notch RevInc
		FXLabel* lblRev=new FXLabel(controls,"&Revolution Inc:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblRev->setFont(mainFont);
		spinRevInc=new FXSpinner(controls,6,this,ID_REV_INC,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinRevInc->setFont(mainFont);
		spinRevInc->setRange(-3600,3600);

		//Width
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);
				
		//Height
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);
		
		//POS x
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		//POS y
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkColors->setFont(mainFont);	

		  // The sample
		sample=new FXDial(mtxSamples,
		NULL,0,
		DIAL_HORIZONTAL|FRAME_RAISED|FRAME_THICK|LAYOUT_CENTER_X|LAYOUT_CENTER_Y|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,
		50,55,100,50);
		sample->setNotchColor(FXRGBA(255,130,10,255));
		BaseColor=sample->getBaseColor();
		ShadowColor=sample->getShadowColor();
		HiliteColor=sample->getHiliteColor();
		BorderColor=sample->getBorderColor();
		BackColor=sample->getBackColor();
		NotchColor=sample->getNotchColor();
		spinw->setValue(sample->getWidth());
		spinh->setValue(sample->getHeight());
		spinPosX->setValue(sample->getX());
		spinPosY->setValue(sample->getY());
		spinNotchOffset->setValue(sample->getNotchOffset());
		spinRevInc->setValue(sample->getRevolutionIncrement());
		spinNotchSpace->setValue(sample->getNotchSpacing());
		sample->hide();
	

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

DialDialog::~DialDialog(){}

long DialDialog::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	switch (style)
	{
		case 0:	style|=FRAME_NONE; break;
		case 1:	style|=FRAME_NONE; break;
		case 2:	style|=FRAME_RAISED; break;
		case 3:	style|=FRAME_THICK; break;
		case 4:	style|=FRAME_GROOVE; break;
		case 5:	style|=FRAME_RIDGE; break;
		case 6:	style|=FRAME_LINE; break;
	}
	sample->setFrameStyle(style);
	return 1;
}

long DialDialog::onCmdDirection(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getDialStyle();
	style=combostyle->getCurrentItem();
	switch (style)
	{
		case 0:	style|=DIAL_HORIZONTAL; break;
		case 1:	style|=DIAL_VERTICAL; break;
	}
	sample->setDialStyle(style);
	sample->update();
	return 1;
}

long DialDialog::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	switch (style)
	{
		case 0:	style|=LAYOUT_NORMAL; break;
		case 1:	style|=LAYOUT_SIDE_TOP; break;
		case 2:	style|=LAYOUT_SIDE_BOTTOM; break;
		case 3:	style|=LAYOUT_SIDE_LEFT; break;
		case 4:	style|=LAYOUT_SIDE_RIGHT; break;
		case 5:	style|=LAYOUT_FILL_COLUMN; break;
		case 6:	style|=LAYOUT_FILL_ROW; break;
		case 7:	style|=LAYOUT_LEFT; break;
		case 8:	style|=LAYOUT_RIGHT; break;
		case 9:	style|=LAYOUT_CENTER_X; break;
		case 10:	style|=LAYOUT_FIX_X; break;
		case 11:	style|=LAYOUT_TOP; break;
		case 12:	style|=LAYOUT_BOTTOM; break;
		case 13:	style|=LAYOUT_CENTER_Y; break;
		case 14:	style|=LAYOUT_FIX_Y; break;
		case 15:	style|=LAYOUT_FIX_WIDTH; break;
		case 16:	style|=LAYOUT_FIX_HEIGHT; break;
		case 17:	style|=LAYOUT_MIN_WIDTH; break;
		case 18:	style|=LAYOUT_MIN_HEIGHT; break;
		case 19:	style|=LAYOUT_FILL_X; break;
	}
	sample->setLayoutHints(style);	
	 return 1;
}

long DialDialog::onCmdToolTip(FXObject*,FXSelector,void*)
{
	sample->setTipText(txtTooltip->getText());
	return 1;
}

long DialDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long DialDialog::onCmdHelp(FXObject*,FXSelector,void*)
{
	sample->setHelpText(txtHelp->getText());
	return 1;
}

long DialDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	if (txtTarget->getText()=="") txtTarget->setText("NULL");
	return 1;
}

long DialDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long DialDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long DialDialog::onCmdNotchSpace(FXObject*,FXSelector,void*)
{
   sample->setNotchSpacing(spinNotchSpace->getValue());
   return 1;
}

long DialDialog::onCmdRevInc(FXObject*,FXSelector,void*)
{
   sample->setRevolutionIncrement(spinRevInc->getValue());
   return 1;
}

long DialDialog::onCmdNotchOffset(FXObject*,FXSelector,void*)
{
   sample->setNotchOffset(spinNotchOffset->getValue());
   return 1;
}

long DialDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	return 1;
}

long DialDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long DialDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long DialDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long DialDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long DialDialog::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
	sample->setBaseColor(BaseColor);
	return 1;
}

long DialDialog::onCmdNotchColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Notch Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	NotchColor=colordlg->getRGBA();
	sample->setNotchColor(NotchColor);
	return 1;
}

long DialDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long DialDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long DialDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long DialDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}

long DialDialog::onCmdResults(FXObject*,FXSelector,void*)
{
              FXString Resultstxt;
              FXString strItems;
	FXString* SumRes;
	FXString TipStr;
	FXString TotalD;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjCols;
	FXString ObjTarget;
	FXString ObjSelector;
	FXString ObjTip;
	FXString ObjIcon;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
	FXString ObjNotchSpace;
	FXString NotchSpaceStr;
	FXString ObjNotchOffset;
	FXString NotchOffsetStr;
	FXString ObjRevInc;
	FXString RevIncStr;
	FXString ObjHelp;
	FXString HelpStr;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString NotchColorStr;
	FXString ObjOpts;

	DeclareStr="FXDial* ";
	newObjectStr="=new FXDial(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjTip=txtTooltip->getText();
	TipStr=ObjName+"->setTipText("+ObjTip+");\n";
	ObjTarget=txtTarget->getText()+",";
	ObjSelector=txtSelector->getText()+",";
	ObjOpts=combostyle->getText()+"|"+combolayout->getText()+"|"+comboframe->getText()+",";
	ObjNotchSpace=FXStringVal(spinNotchSpace->getValue(),10);
	ObjNotchOffset=FXStringVal(spinNotchOffset->getValue(),10);
	ObjRevInc=FXStringVal(spinRevInc->getValue(),10);
	ObjHelp=txtHelp->getText();
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	NotchSpaceStr=ObjName+"->setNotchSpacing("+ObjNotchSpace+");\n";
	NotchOffsetStr=ObjName+"->setNotchOffset("+ObjNotchOffset+");\n";
	RevIncStr=ObjName+"->setRevolutionIncrement("+ObjRevInc+");\n";
	HelpStr=ObjName+"->setHelpText("+ObjHelp+");\n";
	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkColors->getCheck())==TRUE)
	{
	NotchColorStr=ObjName+"->setNotchColor(FXRGBA("+FXStringVal(FXREDVAL(NotchColor))+","+
		FXStringVal(FXGREENVAL(NotchColor))+","+FXStringVal(FXBLUEVAL(NotchColor))+","+
		FXStringVal(FXALPHAVAL(NotchColor))+"));\n";
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=ObjName+"->setBaseColor(FXRGBA("+FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		BaseColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
		NotchColorStr="";
	}
	
	TotalD=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
		NotchColorStr+BackColorStr+ShadowColorStr+BorderColorStr+BaseColorStr+HiliteColorStr+
		TipStr+HelpStr+NotchSpaceStr+NotchOffsetStr+RevIncStr;

	SumRes=&TotalD;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	sample->hide();
	return 1;
}