#ifndef GROUPDIALOG_H
#define GROUPDIALOG_H

class GroupDialog: public FXDialogBox
{
	FXDECLARE(GroupDialog)
	protected:
		FXFont* mainFont;
		FXGroupBox* sample;
		FXToolbar*	mdiTools;
		FXHorizontalFrame* buttons;
		FXTextField* txtName;
		FXTextField* txtOwner;
		FXTextField* txtTitle;
		FXComboBox* cmbFrame;
		FXButton*	btnFont;
		FXText* txtResults;
		FXCheckButton* chkDeclare;
		FXCheckButton* chkColors;
		FXCheckButton*	chkFont;
		FXFont*	myfont;
		FXFontDialog*	fontdlg;
		FXColorDialog* colordlg;
		FXSpinner*	spinw;
		FXSpinner*	spinh;
		FXSpinner*	spinPosX;
		FXSpinner*	spinPosY;
		FXColor	BaseColor;
		FXColor	ShadowColor;
		FXColor	BorderColor;
		FXColor	HiliteColor;
		FXColor	BackColor;
		FXColor	TextColor;
		FXButton* btnBaseColor;
		FXButton* btnShadowColor;
		FXButton* btnBorderColor;
		FXButton* btnHiliteColor;
		FXButton* btnBackColor;
		FXButton* btnTextColor;
		FXComboBox*	comboiconpos;
		FXComboBox*	comboalign;
		FXComboBox*	combolayout;
		FXComboBox*	comboframe;
		FXComboBox*	combostyle;		
		FXButton*	btnOK;
		FXButton*	btnCancel;
		
	private:
		GroupDialog(){}
	public:
	enum {
		ID_RESULTS=FXDialogBox::ID_LAST,
		ID_TOOLBARGRIP,
		ID_NAME,
		ID_TITLE,
		ID_FRAME,
		ID_STYLE,
		ID_WIDTH,
		ID_HEIGHT,
		ID_POSX,
		ID_POSY,
		ID_FONT,
		ID_FONT_DECLARE,
		ID_TEXT_COLOR,
		ID_BASE_COLOR,
		ID_HILITE_COLOR,
		ID_SHADOW_COLOR,
		ID_BORDER_COLOR,
		ID_BACK_COLOR,
		ID_DECLARE,
		ID_COLOR_DECLARE,
		ID_OWNER
};
	public:
		long onCmdName(FXObject*,FXSelector,void*);
		long onCmdOwner(FXObject*,FXSelector,void*);
		long onCmdFrame(FXObject*,FXSelector,void*);
		long onCmdStyle(FXObject*,FXSelector,void*);
		long onCmdWidth(FXObject*,FXSelector,void*);
		long onCmdHeight(FXObject*,FXSelector,void*);
		long onCmdPosX(FXObject*,FXSelector,void*);
		long onCmdPosY(FXObject*,FXSelector,void*);
		long onCmdResults(FXObject*,FXSelector,void*);
		long onCmdBaseColor(FXObject*,FXSelector,void*);
		long onCmdBorderColor(FXObject*,FXSelector,void*);
		long onCmdHiliteColor(FXObject*,FXSelector,void*);
		long onCmdShadowColor(FXObject*,FXSelector,void*);
		long onCmdBackColor(FXObject*,FXSelector,void*);
		long onCmdColorDeclare(FXObject*,FXSelector,void*);
		long onCmdDeclare(FXObject*,FXSelector,void*);
		long onCmdTitle(FXObject*,FXSelector,void*);
		long onCmdFont(FXObject*,FXSelector,void*);
		long onCmdTextColor(FXObject*,FXSelector,void*);
		long onCmdFontDeclare(FXObject*,FXSelector,void*);
		
	public:
	GroupDialog(FXWindow* owner);
	virtual ~GroupDialog();
};
#endif
