/********************************************************************************
*                                                                               *
*                                 List  Creator                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#ifndef LISTBOXDIALOG_H
#define LISTBOXDIALOG_H

class ListBoxDialog : public FXDialogBox
 {
  FXDECLARE(ListBoxDialog)
protected:
	FXToolbar*	mdiTools;
	FXHorizontalFrame* buttons;
	FXListBox*	sample;
	FXTabItem*	tab1;
	FXTabItem*	tab2;

	FXTextField*	txtOptionName;
	FXTextField*	txtOptionIcon;
	FXTextField*	txtName;
	FXTextField*	txtOwner;
	FXTextField*	txtTarget;
	FXTextField*	txtSelector;
	FXTextField*	txtTip;
	FXFont*	mainFont;
	FXFont*	myfont;
	FXFontDialog*	fontdlg;
	FXButton*	btnFont;
	FXButton*	btnReplace;
	FXCheckButton*	chkDeclare;
	FXCheckButton*	chkFont;
	FXSpinner*	spinCols;
	FXSpinner*	spinw;
	FXSpinner*	spinh;
	FXSpinner*	spinPosX;
	FXSpinner*	spinPosY;
	FXColor	BaseColor;
	FXColor	ShadowColor;
	FXColor	BorderColor;
	FXColor	HiliteColor;
	FXColor	BackColor;
	FXColor	TextColor;
	FXButton* btnBaseColor;
	FXButton* btnShadowColor;
	FXButton* btnBorderColor;
	FXButton* btnHiliteColor;
	FXButton* btnBackColor;
	FXButton* btnTextColor;
	FXComboBox*	comboiconpos;
	FXComboBox*	comboalign;
	FXComboBox*	combolayout;
	FXComboBox*	comboframe;
	FXComboBox*	combostyle;
	FXButton*	btnOK;
	FXButton*	btnCancel;
	
private:
  ListBoxDialog(){}
public:
  enum {
    ID_RESULTS=FXDialogBox::ID_LAST,
    ID_COLS,
    ID_NAME,
    ID_OWNER,
    ID_TARGET,
    ID_TIP,
    ID_LAYOUT,
    ID_FRAME,
    ID_SELECTOR,
    ID_ADD,
    ID_OPTION_NAME,
    ID_OPTION_ICON,
    ID_REMOVE,
    ID_REPLACE,
    ID_CLEAR,
    ID_FONT,
    ID_DECLARE,
    ID_FONT_DECLARE,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_TOOLTIP
};

public:
  long onCmdRowNumber(FXObject*,FXSelector,void*);
  long onCmdAdd(FXObject*,FXSelector,void*);
  long onCmdOptionName(FXObject*,FXSelector,void*);
  long onCmdOptionIcon(FXObject*,FXSelector,void*);
  long onCmdRemove(FXObject*,FXSelector,void*);
  long onCmdClear(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdOwner(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdReplace(FXObject*,FXSelector,void*);
  long onCmdTip(FXObject*,FXSelector,void*);
public:
  ListBoxDialog(FXWindow* owner);
  virtual ~ListBoxDialog();
  };

#endif
