// inludes
#include "/usr/local/include/fox/fx.h"
#include "MainDialog.h"
#include "icons.h"
#include "vars.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Map
FXDEFMAP(MainDialog) MainDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_APPNAME,MainDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_APPVENDOR,MainDialog::onCmdVendor),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_CLASS_NAME,MainDialog::onCmdClassName),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_RESULTS,MainDialog::onCmdMainRes),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_VARS,MainDialog::onCmdVars),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_ADD_VAR,MainDialog::onCmdAddVar),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_CLEAR_VARS,MainDialog::onCmdClearVars),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_REMOVE_VAR,MainDialog::onCmdRemoveVar),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_ENUMS,MainDialog::onCmdEnums),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_ADD_ENUM,MainDialog::onCmdAddEnum),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_REMOVE_ENUM,MainDialog::onCmdRemoveEnum),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_METHODS,MainDialog::onCmdMethods),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_ADD_METHOD,MainDialog::onCmdAddMethod),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_REMOVE_METHOD,MainDialog::onCmdRemoveMethod),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_FONT,MainDialog::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_STATUS_BAR,MainDialog::onCmdStatusBar),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_VAR_TYPE,MainDialog::onCmdVarType),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_TOOLBAR,MainDialog::onCmdToolBar),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_TOOLBOX,MainDialog::onCmdToolBox),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_TIP,MainDialog::onCmdToolTip),
  FXMAPFUNC(SEL_COMMAND,MainDialog::ID_CLASS_TYPE,MainDialog::onCmdClassType),
};


// ButtonApp implementation
FXIMPLEMENT(MainDialog,FXDialogBox,MainDialogMap,ARRAYNUMBER(MainDialogMap))

// Make some windows
MainDialog::MainDialog(FXWindow* owner):FXDialogBox(owner,"Main Application",DECOR_TITLE|DECOR_BORDER,0)
{
  mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
              buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	
	FXTabBook* MainTabs=new FXTabBook(this,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_RIGHT);
	tab1=new FXTabItem(MainTabs,"&Basics",NULL);
		 FXMatrix* mtxBasics=new FXMatrix(MainTabs,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		 FXLabel *lblmName=new FXLabel(mtxBasics,"&Name:\tApplication name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		 lblmName->setFont(mainFont);
		 txtAppName=new FXTextField(mtxBasics,15,this,ID_APPNAME,LAYOUT_LEFT|FRAME_SUNKEN);
		 txtAppName->setFont(mainFont);

	 	 FXLabel *lblVendor=new FXLabel(mtxBasics,"&Editor:\tApplication Editor",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		 lblVendor->setFont(mainFont);
		 txtAppVendor=new FXTextField(mtxBasics,15,this,ID_APPVENDOR,LAYOUT_LEFT|FRAME_SUNKEN|JUSTIFY_LEFT);
		 txtAppVendor->setFont(mainFont);

		 FXLabel *lblClass=new FXLabel(mtxBasics,"&Class name:\tApplication class name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		 lblClass->setFont(mainFont);
		 txtClassName=new FXTextField(mtxBasics,15,this,ID_CLASS_NAME,LAYOUT_LEFT|FRAME_SUNKEN|JUSTIFY_LEFT);
		 txtClassName->setFont(mainFont);
	
		 FXLabel *lblClassType=new FXLabel(mtxBasics,"&Base Class:\tParent class name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		 lblClassType->setFont(mainFont);
		 cmbClassTypes=new FXComboBox(mtxBasics,11,10,this,ID_CLASS_TYPE,COMBOBOX_INSERT_LAST||FRAME_SUNKEN|LAYOUT_SIDE_TOP);
		 cmbClassTypes->setFont(mainFont);
		 for (int i=0; i<21; i++) cmbClassTypes->appendItem(VarTypesStr[i]);
		 cmbClassTypes->setCurrentItem(0);

		 //font
		 btnFont=new FXButton(mtxBasics,"&Font\tSelect Main Font",fonticon,this,ID_FONT,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		 btnFont->setFont(mainFont);
		 myfont=new FXFont(getApp(),"helvetica",12);
	
		 //Status Bar
		 chkStatusBar=new FXCheckButton(mtxBasics,"Status Bar",this,ID_STATUS_BAR,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		 chkStatusBar->setFont(mainFont);chkStatusBar->setFont(mainFont);chkStatusBar->setBackColor(FXRGBA(0,255,255,255));
		 chkStatusBar->setShadowColor(FXRGBA(126,126,126,255));
	 	 chkStatusBar->setBorderColor(FXRGBA(0,0,0,255));
		 chkStatusBar->setBaseColor(FXRGBA(192,192,192,255));
		 chkStatusBar->setHiliteColor(FXRGBA(255,255,255,255));
		 chkStatusBar->setTextColor(FXRGBA(0,0,0,255));

		 chkToolBar=new FXCheckButton(mtxBasics,"Tool Bar",this,ID_TOOLBAR,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		 chkToolBar->setFont(mainFont);chkToolBar->setFont(mainFont);chkToolBar->setBackColor(FXRGBA(0,255,255,255));
		 chkToolBar->setShadowColor(FXRGBA(126,126,126,255));
	 	 chkToolBar->setBorderColor(FXRGBA(0,0,0,255));
		 chkToolBar->setBaseColor(FXRGBA(192,192,192,255));
		 chkToolBar->setHiliteColor(FXRGBA(255,255,255,255));
		 chkToolBar->setTextColor(FXRGBA(0,0,0,255));
                             		
		 chkToolTip=new FXCheckButton(mtxBasics,"Tool Tips",this,ID_TIP,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		 chkToolTip->setFont(mainFont);chkToolTip->setFont(mainFont);chkToolTip->setBackColor(FXRGBA(0,255,255,255));
		 chkToolTip->setShadowColor(FXRGBA(126,126,126,255));
		 chkToolTip->setBorderColor(FXRGBA(0,0,0,255));
		 chkToolTip->setBaseColor(FXRGBA(192,192,192,255));
		 chkToolTip->setHiliteColor(FXRGBA(255,255,255,255));
		 chkToolTip->setTextColor(FXRGBA(0,0,0,255));

  	  tab2=new FXTabItem(MainTabs,"&Variables",NULL);
  	  	FXMatrix* mtxVars=new FXMatrix(MainTabs,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		cmbVarTypes=new FXComboBox(mtxVars,11,10,this,ID_VAR_TYPE,COMBOBOX_INSERT_LAST||FRAME_SUNKEN|LAYOUT_SIDE_TOP);
		cmbVarTypes->setFont(mainFont);
		for (int i=0; i<21; i++) cmbVarTypes->appendItem(VarTypesStr[i]);
		cmbVarTypes->setCurrentItem(0);
		txtAddVar=new FXTextField(mtxVars,15,this,ID_ADD_VAR,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		txtAddVar->setFont(mainFont);
		lstVars=new FXList(mtxVars,10,this,ID_VARS,LISTBOX_NORMAL|LAYOUT_FILL_X);
		lstVars->appendItem("FXTextField* Test");
		lstVars->setFont(mainFont);
		
		FXHorizontalFrame* hfrmOptions=new FXHorizontalFrame(mtxVars,LAYOUT_NORMAL|FRAME_RAISED,1,1,100,50);
		   FXButton* btnRemoveVar=new FXButton(hfrmOptions,"\tRemove line from var list",deleteicon,this,ID_REMOVE_VAR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
		   btnRemoveVar->setFont(mainFont);
		   //Clear
		   FXButton* btnClear=new FXButton(hfrmOptions,"Clear\tClear the list",NULL,this,ID_CLEAR_VARS,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnClear->setFont(mainFont);		
		
	tab3=new FXTabItem(MainTabs,"&Enumerations",NULL);
		FXMatrix* mtxEnums=new FXMatrix(MainTabs,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		FXLabel* lblAddEnum=new FXLabel(mtxEnums,"Add Enum\tAdd New Enum",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,126,25);
		lblAddEnum->setFont(mainFont);
		txtAddEnum=new FXTextField(mtxEnums,20,this,ID_ADD_ENUM,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		txtAddEnum->setFont(mainFont);
		lstEnums=new FXList(mtxEnums,10,this,ID_ENUMS,LISTBOX_NORMAL|LAYOUT_FILL_X);
		lstEnums->appendItem("ID_NEW");
		lstEnums->setFont(mainFont);
		FXButton* btnRemoveEnum=new FXButton(mtxEnums,"\tRemove Line from enum List",deleteicon,this,ID_REMOVE_ENUM,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
		btnRemoveEnum->setFont(mainFont);
	
	tab4=new FXTabItem(MainTabs,"M&ethods",NULL);
		FXMatrix* mtxMethods=new FXMatrix(MainTabs,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);	
		FXLabel* lblAddMethod=new FXLabel(mtxMethods,"Add Method\tAdd New Method",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,126,25);
		lblAddMethod->setFont(mainFont);
		txtAddMethod=new FXTextField(mtxMethods,20,this,ID_ADD_METHOD,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		txtAddMethod->setFont(mainFont);
		lstMethods=new FXList(mtxMethods,10,this,ID_METHODS,LISTBOX_NORMAL|LAYOUT_FILL_X);
		lstMethods->appendItem("onCmd...");
		lstMethods->setFont(mainFont);
		FXButton* btnRemoveMethod=new FXButton(mtxMethods,"\tRemove line from method list",deleteicon,this,ID_REMOVE_METHOD,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
		btnRemoveMethod->setFont(mainFont);

		//     Main
	btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",createicon,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
	btnCancel=new FXButton(buttons,"Close\tClose the Dialog",createicon,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
}

MainDialog::~MainDialog(){}

long MainDialog::onCmdName(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdVendor(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdClassName(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdVars(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdAddVar(FXObject*,FXSelector,void*)
{
	lstVars->appendItem(txtAddVar->getText(),NULL);
	txtAddVar->setText("");
	return 1;
}

long MainDialog::onCmdRemoveVar(FXObject*,FXSelector,void*)
{
	lstVars->removeItem(lstVars->getCurrentItem());
	return 1;
}

long MainDialog::onCmdClearVars(FXObject*,FXSelector,void*)
{
	  lstVars->clearItems();
	  return 1;
}

long MainDialog::onCmdEnums(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdAddEnum(FXObject*,FXSelector,void*)
{
	lstEnums->appendItem(txtAddEnum->getText(),NULL);
	txtAddEnum->setText("");
	return 1;
}

long MainDialog::onCmdRemoveEnum(FXObject*,FXSelector,void*)
{
	lstEnums->removeItem(lstEnums->getCurrentItem());
	return 1;
}

long MainDialog::onCmdMethods(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdAddMethod(FXObject*,FXSelector,void*)
{
	lstMethods->appendItem(txtAddMethod->getText(),NULL);
	txtAddMethod->setText("");
	return 1;
}

long MainDialog::onCmdRemoveMethod(FXObject*,FXSelector,void*)
{
	lstMethods->removeItem(lstMethods->getCurrentItem());
	return 1;
}

//   font  mainFont      
long MainDialog::onCmdFont(FXObject*,FXSelector,void*)
{
	fontdlg=new FXFontDialog(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	fontdlg->FXDialogBox::execute();
	fontdlg->getFontSelection(fontdesc);
	delete myfont;
	myfont=new FXFont(getApp(),fontdesc);
	myfont->create();
	return 1;
}

long MainDialog::onCmdStatusBar(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdToolBar(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdToolBox(FXObject*,FXSelector,void*)
{
	return 1;
}


long MainDialog::onCmdToolTip(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdMainRes(FXObject*,FXSelector,void*)
{             FXString textMain;
	FXString* SumResM;
	FXString stdVarStr;
	FXString strFont;
	FXString ClassStr;
	FXString VarStr;
	FXString EnumStr;
	FXString MethodStr;
	FXString MapStr;
	FXString FirstMapLine;
	FXString ImpStr;
	FXString LastImpStr;
	FXString CreateStr;
	FXString MethodImp;
	FXString FormStr="// Form begins here\n";
	FXString strStatusBar;
	FXString strToolBar;
	FXString strTips;
	FXString strIncludes;
	FXString TotalM;
	
	if ((chkStatusBar->getCheck())==TRUE)
	{
		strStatusBar="statusbar=new FXStatusbar(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|STATUSBAR_WITH_DRAGCORNER);\n";
		stdVarStr="\t\tFXFont* mainFont;\n\t\tFXStatusbar* statusbar;\n"; 	} 	else 	{
		strStatusBar="";
		stdVarStr="\t\tFXFont* mainFont;\n";
	}
	if ((chkToolBar->getCheck())==TRUE)
	{
		strToolBar="toolbar=new FXToolbar(this,LAYOUT_SIDE_TOP|LAYOUT_FIX_X|PACK_UNIFORM_WIDTH|PACK_UNIFORM_HEIGHT|FRAME_RAISED);\n";
		stdVarStr=stdVarStr+"\t\tFXToolbar* toolbar;\n";
	}
	if ((chkToolTip->getCheck())==TRUE)
	{	
		strTips="FXTooltip* tooltip= new FXTooltip(getApp());\ntooltip->setFont(mainFont);\n";
	}

	strFont="mainFont=new FXFont(getApp(),"+
		ec+myfont->getName()+ec+","+
		FXStringVal((myfont->getSize())/10)+");\n"+strStatusBar+"\n";
	FXString Cname=txtClassName->getText();
	for (int i=0; i<lstVars->getNumItems(); i++)
		VarStr=VarStr+"\t\t"+lstVars->getItemText(i)+";\n";
	VarStr=stdVarStr+VarStr;	
	EnumStr="\t\t"+lstEnums->getItemText(0)+"=FXMainWindow::ID_LAST,\n";
	for (int i=1; i<lstEnums->getNumItems(); i++)
		EnumStr=EnumStr+"\t\t"+lstEnums->getItemText(i)+",\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MethodStr=MethodStr+"\t\t"+"long "+ lstMethods->getItemText(i)+"(FXObject*,FXSelector,void*);\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MapStr=MapStr+"FXMAPFUNC(SEL_COMMAND,"+Cname+"::"+lstEnums->getItemText(i)+","+Cname+"::"+lstMethods->getItemText(i)+"),\n";
	ClassStr="class "+ Cname+": public "+cmbClassTypes->getText()+"\n"+
		"{\n"+"	FXDECLARE("+Cname+")\n"+
		"\tprotected:\n"+
		VarStr+
		"\tprotected:\n"+"\t"+
		Cname+"(){}\n"+
		"\tpublic:\n"+
		"\tenum {\n"+EnumStr+
		"};\n"+
		"\tpublic:\n"+MethodStr+
		"\tpublic:\n\t"+Cname+"(FXApp* a);\n"+"\tvoid create();\n};\n\n";
	FirstMapLine="FXDEFMAP("+Cname+") "+Cname+"Map[]={\n";	
	ImpStr="FXIMPLEMENT("+Cname+",FXMainWindow,"+Cname+"Map,ARRAYNUMBER("+Cname+"Map))\n";
	LastImpStr=Cname+"::"+Cname+"(FXApp* a):FXMainWindow(a,"+ec+txtAppName->getText()+ec+",NULL,NULL,DECOR_ALL,1,1,500,400)\n{\n";
	textMain="int main(int argc,char *argv[])\n{\n\tFXApp application("+
			    ec+txtAppName->getText()+ec+","+
			    ec+txtAppVendor->getText()+ec+
			    ");\n	application.init(argc,argv);\n\tnew "+
			    txtClassName->getText()+
			    "(&application);\n\tapplication.create();\n\treturn application.run();\n}";
	CreateStr="\nvoid "+Cname+"::create()\n"+"{\n\tFXMainWindow::create();\n\tshow(PLACEMENT_SCREEN);\n}\n\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MethodImp=MethodImp+"long "+Cname+"::"+lstMethods->getItemText(i)+"(FXObject*,FXSelector,void*)\n{\n\treturn 1;\n}\n\n";		

	strIncludes="#include "+ec+"/usr/local/include/fox/fx.h"+ec+"\n\n";
	TotalM=strIncludes+ClassStr+FirstMapLine+MapStr+"};\n"+ImpStr+LastImpStr+FormStr+strFont+strToolBar+strTips+"}\n"+CreateStr+MethodImp+textMain;
	
	SumResM=&TotalM;
	editor->insertText(editor->getCursorPos(),SumResM->text(),SumResM->size()-1, FALSE);
	return 1;
}

long MainDialog::onCmdClassType(FXObject*,FXSelector,void*)
{
	return 1;
}

long MainDialog::onCmdVarType(FXObject*,FXSelector,void*)
{
	txtAddVar->setText(cmbVarTypes->getText());
	return 1;
}
