#ifndef MATRIX_DIALOG_H
#define MATRIXDIALOG_H

class MatrixDialog: public FXDialogBox
{
	FXDECLARE(MatrixDialog)
	protected:
		FXFont* mainFont;
		FXMatrix* sample;
		FXToolbar*	mdiTools;
		FXHorizontalFrame* buttons;
		FXTextField* txtName;
		FXTextField* txtOwner;
		FXComboBox* combolayout;
		FXComboBox* comboframe;
		FXComboBox* cmbMatrixStyle;
		FXButton* btnQuit;
		FXText* txtResults;
		FXCheckButton* chkDeclare;
		FXCheckButton* chkColors;
		FXColorDialog*	colordlg;
		FXSpinner*	spinCols;
		FXSpinner*	spinw;
		FXSpinner*	spinh;
		FXSpinner*	spinPosX;
		FXSpinner*	spinPosY;
		FXColor	BaseColor;
		FXColor	ShadowColor;
		FXColor	BorderColor;
		FXColor	HiliteColor;
		FXColor	BackColor;
		FXColor	TextColor;
		FXButton* btnBaseColor;
		FXButton* btnShadowColor;
		FXButton* btnBorderColor;
		FXButton* btnHiliteColor;
		FXButton* btnBackColor;
		FXButton* btnTextColor;
		FXComboBox*	comboalign;
		FXButton*	btnOK;
		FXButton*	btnCancel;
			
	private:
		MatrixDialog(){}
	public:
	enum {
		ID_RESULTS=FXDialogBox::ID_LAST,
		ID_COLS,
		ID_TOOLBARGRIP,
		ID_NAME,
		ID_LAYOUT,
		ID_FRAME,
		ID_MTX_STYLE,
		ID_WIDTH,
		ID_HEIGHT,
		ID_POSX,
		ID_POSY,
		ID_BASE_COLOR,
		ID_HILITE_COLOR,
		ID_SHADOW_COLOR,
		ID_BORDER_COLOR,
		ID_BACK_COLOR,
		ID_DECLARE,
		ID_COLOR_DECLARE,
		ID_OWNER
};
	public:
		long onCmdName(FXObject*,FXSelector,void*);
		long onCmdOwner(FXObject*,FXSelector,void*);
		long onCmdCol(FXObject*,FXSelector,void*);
		long onCmdLayout(FXObject*,FXSelector,void*);
		long onCmdFrame(FXObject*,FXSelector,void*);
		long onCmdMatrixStyle(FXObject*,FXSelector,void*);
		long onCmdWidth(FXObject*,FXSelector,void*);
		long onCmdHeight(FXObject*,FXSelector,void*);
		long onCmdPosX(FXObject*,FXSelector,void*);
		long onCmdPosY(FXObject*,FXSelector,void*);
		long onCmdResults(FXObject*,FXSelector,void*);
		long onCmdBaseColor(FXObject*,FXSelector,void*);
		long onCmdBorderColor(FXObject*,FXSelector,void*);
		long onCmdHiliteColor(FXObject*,FXSelector,void*);
		long onCmdShadowColor(FXObject*,FXSelector,void*);
		long onCmdBackColor(FXObject*,FXSelector,void*);
		long onCmdColorDeclare(FXObject*,FXSelector,void*);
		long onCmdDeclare(FXObject*,FXSelector,void*);
	public:
	MatrixDialog(FXWindow* owner);
	virtual ~MatrixDialog();
};
#endif
