/********************************************************************************
*                                                                               *
*                                 Create MenuButton                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef MENUBUTTONDIALOG_H
#define MENUBUTTONDIALOG_H

// Mini application object
class MenuButtonDialog : public FXDialogBox
 {
  FXDECLARE(MenuButtonDialog)
protected:
  FXMenuButton*	sample;        // Object being tested
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;
  FXColorDialog*	colordlg;
  FXButton*	btnFont;
  FXTextField*	txtTooltip;
  FXString	buttonalign;
  FXFont*	myfont;
  FXFont*	mainFont;
  FXFontDialog*	fontdlg;
  FXFont*	toolFont;
  FXTextField*	txtLabel;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtIcon;
  FXTextField*	txtMenu;
  FXComboBox*	combodirection;
  FXSpinner*	spinw;
 FXSpinner*	spinh;
 FXSpinner*	spinPosX;
 FXSpinner*	spinPosY;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkToolStyle;
  FXCheckButton*	chkFont;
  FXCheckButton*	chkColors;
   FXColor	BaseColor;
 FXColor	ShadowColor;
 FXColor	BorderColor;
 FXColor	HiliteColor;
 FXColor	BackColor;
 FXColor	TextColor;
 FXButton* btnBaseColor;
 FXButton* btnShadowColor;
 FXButton* btnBorderColor;
 FXButton* btnHiliteColor;
 FXButton* btnBackColor;
 FXButton* btnTextColor;
 FXComboBox*	comboiconpos;
 FXComboBox*	comboalign;
 FXComboBox*	combolayout;
 FXComboBox*	comboframe;
 FXComboBox*	combostyle;
 FXButton*	btnOK;
 FXButton*	btnCancel;

private:
  MenuButtonDialog(){}
public:
  enum {
    ID_TEXT=FXDialogBox::ID_LAST,
    ID_TOOLBAR_STYLE,
    ID_TOOLBARGRIP,
    ID_DIRECTION,
    ID_MENU,
    ID_FONT,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_OWNER,
    ID_NAME,
    ID_TOOLTIP,
    ID_ICONPOS,
    ID_ALIGN,
    ID_LAYOUT,
    ID_FRAME,
    ID_ICON,
    ID_DECLARE,
    ID_RESULTS,
    ID_COLOR_DECLARE,
    ID_TEXT_COLOR,
    ID_FONT_DECLARE,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR
};

public:
  long onCmdToolbarStyle(FXObject*,FXSelector,void*);
  long onCmdText(FXObject*,FXSelector,void*);
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdIconPos(FXObject*,FXSelector,void*);
  long onCmdAlign(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdToolTip(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdIcon(FXObject*,FXSelector,void*);
  long onCmdTextColor(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdDirection(FXObject*,FXSelector,void*);
  long onCmdMenu(FXObject*,FXSelector,void*);

public:
  MenuButtonDialog(FXWindow* owner);
  virtual ~MenuButtonDialog();
  };

#endif
