/********************************************************************************
*                                                                               *
*                                 Create Scrollbar                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "ScrollBarDialog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(ScrollBarDialog) ScrollBarDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_NAME,ScrollBarDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_WIDTH,ScrollBarDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_HEIGHT,ScrollBarDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_POSX,ScrollBarDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_POSY,ScrollBarDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_RESULTS,ScrollBarDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_TARGET,ScrollBarDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_SELECTOR,ScrollBarDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_DECLARE,ScrollBarDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_COLOR_DECLARE,ScrollBarDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_BORDER_COLOR,ScrollBarDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_HILITE_COLOR,ScrollBarDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_SHADOW_COLOR,ScrollBarDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_BACK_COLOR,ScrollBarDialog::onCmdBackColor),
  FXMAPFUNC(SEL_COMMAND,ScrollBarDialog::ID_DIRECTION,ScrollBarDialog::onCmdDirection),
 };

// ButtonApp implementation
FXIMPLEMENT(ScrollBarDialog,FXDialogBox,ScrollBarDialogMap,ARRAYNUMBER(ScrollBarDialogMap))

// Make some windows
ScrollBarDialog::ScrollBarDialog(FXWindow* owner):FXDialogBox(owner,"Button Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
         	
		// HIlite
		btnHiliteColor=new FXButton(mdiTools,"\tHilite color",coloricon,this,ID_HILITE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setHiliteColor(FXRGBA(255,0,0,255));

		// 
		btnBorderColor=new FXButton(mdiTools,"\tBorder color",coloricon,this,ID_BORDER_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setBorderColor(FXRGBA(0,255,0,255));

		// 
		btnShadowColor=new FXButton(mdiTools,"\tShadow color",coloricon,this,ID_SHADOW_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setShadowColor(FXRGBA(255,0,0,255));

		// 
		btnBackColor=new FXButton(mdiTools,"\tBack color",coloricon,this,ID_BACK_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setBackColor(FXRGBA(255,0,0,255));

	FXMatrix* controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);		
             	
		//  
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("dial");
	
		//
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);

		// 
		FXLabel *lblTooltip=new FXLabel(controls,"&Tool Tip:\tTip when the mouse is over",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTooltip->setFont(mainFont);
		txtTooltip=new FXTextField(controls,15,this,ID_TOOLTIP,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTooltip->setFont(mainFont);

		//
		FXLabel *lblTarget=new FXLabel(controls,"&Target,ID:\tTarget,ID",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTarget->setFont(mainFont);
		txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTarget->setFont(mainFont);

		//Selector
		FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblSelector->setFont(mainFont);
		txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
		txtSelector->setFont(mainFont);
	
		//Direction
		FXLabel *lblDir=new FXLabel(controls,"&Direction:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblDir->setFont(mainFont);
		combostyle=new FXComboBox(controls,15,2,this,ID_DIRECTION,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<2; i++){  combostyle->appendItem(strScrollBarStyle[i]);         }
		combostyle->setCurrentItem(0);
		
		// 
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);
				
		// 
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);
		
		// 
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		// 
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkColors->setFont(mainFont);	

		// The sample
		sample=new FXScrollbar(mtxSamples,NULL,0,
		SCROLLBAR_VERTICAL,	1,1,10,1);
		ShadowColor=sample->getShadowColor();
		HiliteColor=sample->getHiliteColor();
		BorderColor=sample->getBorderColor();
		BackColor=sample->getBackColor();
		spinw->setValue(sample->getWidth());
		spinh->setValue(sample->getHeight());
		spinPosX->setValue(sample->getX());
		spinPosY->setValue(sample->getY());
		sample->hide();
		
  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

ScrollBarDialog::~ScrollBarDialog(){}

long ScrollBarDialog::onCmdDirection(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getScrollbarStyle();
	style=combostyle->getCurrentItem();
	switch (style)
	{
		case 0:	style|=SCROLLBAR_VERTICAL; break;		
		case 1:	style|=SCROLLBAR_HORIZONTAL; break;
	}
	sample->setScrollbarStyle(style);
	sample->update();
	return 1;
}

long ScrollBarDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long ScrollBarDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	if (txtTarget->getText()=="") txtTarget->setText("NULL");
	return 1;
}

long ScrollBarDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long ScrollBarDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long ScrollBarDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	sample->update();
	return 1;
}

long ScrollBarDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long ScrollBarDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long ScrollBarDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long ScrollBarDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long ScrollBarDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long ScrollBarDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long ScrollBarDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long ScrollBarDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}

long ScrollBarDialog::onCmdResults(FXObject*,FXSelector,void*)
{
              FXString Resultstxt;
              FXString strItems;
	FXString* SumRes;
	FXString TipStr;
	FXString TotalD;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjTarget, ObjSelector;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString HiliteColorStr;
	FXString SlotColorStr;
	FXString ObjOpts;

	DeclareStr="FXScrollbar* ";
	newObjectStr="=new FXScrollbar(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjTarget=txtTarget->getText()+",";
	ObjSelector=txtSelector->getText()+",";
	ObjOpts=combostyle->getText()+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkColors->getCheck())==TRUE)
	{
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
	}
	
	TotalD=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
		BackColorStr+ShadowColorStr+BorderColorStr+HiliteColorStr;

	SumRes=&TotalD;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	sample->hide();
	return 1;
}
