/********************************************************************************
*                                                                               *
*                                 Create ArrowButton              *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "TableDialog.h"
#include "vars.h"

FXDEFMAP(TableDialog) TableDialogMap[]={
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_NAME,TableDialog::onCmdName),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_OWNER,TableDialog::onCmdOwner),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_DECLARE,TableDialog::onCmdDeclare),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_ROWS,TableDialog::onCmdRows),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_COLS,TableDialog::onCmdCols),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_GRIDS,TableDialog::onCmdGrids),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_WIDTH,TableDialog::onCmdWidth),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_HEIGHT,TableDialog::onCmdHeight),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_POSX,TableDialog::onCmdPosX),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_POSY,TableDialog::onCmdPosY),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_LEADROWS,TableDialog::onCmdLeadRows),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_LEADCOLS,TableDialog::onCmdLeadCols),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_TRAILROWS,TableDialog::onCmdTrailRows),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_TRAILCOLS,TableDialog::onCmdTrailCols),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_TARGET,TableDialog::onCmdTarget),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_SELECTOR,TableDialog::onCmdSelector),
FXMAPFUNC(SEL_COMMAND,TableDialog::ID_RESULTS,TableDialog::onCmdResults),
};
FXIMPLEMENT(TableDialog,FXDialogBox,TableDialogMap,ARRAYNUMBER(TableDialogMap))
TableDialog::TableDialog(FXWindow* owner):FXDialogBox(owner,"TableDialog",DECOR_TITLE|DECOR_BORDER,0)
{
// Form begins here
mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
controls=new FXMatrix(this,2,MATRIX_BY_COLUMNS|LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);

FXLabel*lblName=new FXLabel(controls,"Name:\tName of the Object",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblName->setFont(mainFont);
txtName=new FXTextField(controls,10,this,ID_NAME,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_THICK,1,1,1,1);
txtName->setFont(mainFont);
txtName->setTipText("Object Name");
txtName->setText("tbl");

FXLabel*lblOwner=new FXLabel(controls,"Owner:\tOwner of the Object",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblOwner->setFont(mainFont);
txtOwner=new FXTextField(controls,10,this,ID_OWNER,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_THICK,1,1,1,1);
txtOwner->setFont(mainFont);
txtOwner->setTipText("Object Owner");

FXLabel*lblRows=new FXLabel(controls,"Rows:\tNumber of Rows",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblRows->setFont(mainFont);
spinRows=new FXSpinner(controls,8,this,ID_ROWS,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinRows->setFont(mainFont);
spinRows->setTipText("Table Rows");
spinRows->setValue(1);

FXLabel*lblCols=new FXLabel(controls,"Columns:\tNumber of Rows",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblCols->setFont(mainFont);
spinCols=new FXSpinner(controls,8,this,ID_COLS,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinCols->setFont(mainFont);
spinCols->setTipText("Table Columns");
spinCols->setValue(1);

FXLabel*lblGrids=new FXLabel(controls,"Gridlines:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblGrids->setFont(mainFont);
comboGrids=new FXComboBox(controls,3,9,this,ID_GRIDS,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|LAYOUT_SIDE_TOP,1,1,1,1);
for (int i=0; i<3; i++) {comboGrids->appendItem(strGrids[i]); }
comboGrids->setFont(mainFont);

FXLabel*lblWidth=new FXLabel(controls,"Width:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblWidth->setFont(mainFont);
spinWidth=new FXSpinner(controls,8,this,ID_WIDTH,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinWidth->setFont(mainFont);
spinWidth->setTipText("");

FXLabel*lblHeight=new FXLabel(controls,"Height:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblHeight->setFont(mainFont);
spinHeight=new FXSpinner(controls,8,this,ID_HEIGHT,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinHeight->setFont(mainFont);
spinHeight->setTipText("");

FXLabel*lblPosX=new FXLabel(controls,"X Pos:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblPosX->setFont(mainFont);
spinPosX=new FXSpinner(controls,8,this,ID_POSX,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinPosX->setFont(mainFont);
spinPosX->setTipText("");

FXLabel*lblPosY=new FXLabel(controls,"Y Pos:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblPosY->setFont(mainFont);
spinPosY=new FXSpinner(controls,8,this,ID_POSY,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinPosY->setFont(mainFont);
spinPosY->setTipText("");

FXLabel*lblLeadRows=new FXLabel(controls,"Leading Rows:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblLeadRows->setFont(mainFont);
spinLeadRows=new FXSpinner(controls,8,this,ID_LEADROWS,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinLeadRows->setFont(mainFont);
spinLeadRows->setTipText("");

FXLabel*lblLeadCols=new FXLabel(controls,"Leading Columns:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblLeadCols->setFont(mainFont);
spinLeadCols=new FXSpinner(controls,8,this,ID_LEADCOLS,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinLeadCols->setFont(mainFont);
spinLeadCols->setTipText("");

FXLabel*lblTrailRows=new FXLabel(controls,"Trailing Rows:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblTrailRows->setFont(mainFont);
spinTrailRows=new FXSpinner(controls,8,this,ID_TRAILROWS,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinTrailRows->setFont(mainFont);
spinTrailRows->setTipText("");

FXLabel*lblTrailCols=new FXLabel(controls,"Trailing Cols:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblTrailCols->setFont(mainFont);
spinTrailCols=new FXSpinner(controls,8,this,ID_TRAILCOLS,LAYOUT_NORMAL|FRAME_NONE,1,1,1,1);
spinTrailCols->setFont(mainFont);
spinTrailCols->setTipText("");

FXLabel*lblTarget=new FXLabel(controls,"Target:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblTarget->setFont(mainFont);
txtTarget=new FXTextField(controls,10,this,ID_TARGET,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_THICK,1,1,1,1);
txtTarget->setFont(mainFont);
txtTarget->setTipText("");

FXLabel*lblSelector=new FXLabel(controls,"Selector:\t",NULL,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,1,1,40,20);
lblSelector->setFont(mainFont);
txtID=new FXTextField(controls,10,this,ID_SELECTOR,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_THICK,1,1,1,1);
txtID->setFont(mainFont);
txtID->setTipText("");

  chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
  chkDeclare->setFont(mainFont);

sample=new FXTable(mtxSamples,5,4,NULL,0,
		TABLE_HOR_GRIDLINES|TABLE_VER_GRIDLINES|LAYOUT_FILL_X|LAYOUT_FILL_Y,
		0,0,0,0, 2,2,2,2);
  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tCancel Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
  sample->hide();
}

TableDialog::~TableDialog(){}

long TableDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long TableDialog::onCmdOwner(FXObject*,FXSelector,void*)
{
	return 1;
}

long TableDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long TableDialog::onCmdRows(FXObject*,FXSelector,void*)
{
	RowsNo=spinRows->getValue();
	ColsNo=spinCols->getValue();
	sample->setTableSize(RowsNo,ColsNo);
	return 1;
}

long TableDialog::onCmdCols(FXObject*,FXSelector,void*)
{
	RowsNo=spinRows->getValue();
	ColsNo=spinCols->getValue();
	sample->setTableSize(RowsNo,ColsNo);
	return 1;
}

long TableDialog::onCmdGrids(FXObject*,FXSelector,void*)
{/*             FXuint style=sample->getTableStyle();
	style=comboGrids->getCurrentItem();
	switch (style)
	{
		case 0:	style|=VERT_GRID; break;
		case 1:	style|=HORZ_GRID; break;
		case 2:	style|=VERT_GRID|HORZ_GRID; break;
	}
	sample->setTableStyle(style);*/
	return 1;
}

long TableDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
	sample->setWidth(spinWidth->getValue());
	sample->update();
	return 1;
}

long TableDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinHeight->getValue());
	sample->update();
	return 1;
}

long TableDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long TableDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinPosY->getValue());
	return 1;
}

long TableDialog::onCmdLeadRows(FXObject*,FXSelector,void*)
{
	sample->setLeadingRows(spinLeadRows->getValue());
	return 1;
}

long TableDialog::onCmdLeadCols(FXObject*,FXSelector,void*)
{
	sample->setLeadingCols(spinLeadCols->getValue());
	return 1;
}

long TableDialog::onCmdTrailRows(FXObject*,FXSelector,void*)
{
	sample->setTrailingRows(spinTrailRows->getValue());
	return 1;
}

long TableDialog::onCmdTrailCols(FXObject*,FXSelector,void*)
{
	sample->setTrailingCols(spinTrailCols->getValue());
	return 1;
}

long TableDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	return 1;
}

long TableDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	return 1;
}

long TableDialog::onCmdResults(FXObject*,FXSelector,void*)
{
	FXString Resultstxt;
              FXString strItems;
	FXString*	SumRes;
	FXString TotalA;

	FXString ObjName;	FXString ObjOwner;
	FXString ObjText;	FXString ObjCols;
	FXString ObjRows;	FXString ObjTarget;
	FXString ObjSelector;
	FXString ObjX;     FXString ObjY;
	FXString ObjW;    FXString ObjH;
	FXString ObjOpts;
	FXString DeclareStr;	FXString newObjectStr;

	DeclareStr="FXTable* ";
	newObjectStr="=new FXTable(";
	ObjName=txtName->getText();
 	ObjOwner=txtOwner->getText()+",";
	ObjTarget=txtTarget->getText()+",";
	ObjSelector=txtID->getText()+",";
	ObjOpts=comboGrids->getText()+",";
	ObjCols=FXStringVal(spinCols->getValue(),10)+",";
	ObjRows=FXStringVal(spinRows->getValue(),10)+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinWidth->getValue(),10)+",";
	ObjH=FXStringVal(spinHeight->getValue(),10);

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";

	TotalA=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjRows+ObjCols+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n";
	SumRes=&TotalA;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	sample->hide();
	return 1;
}
