/********************************************************************************
*                                                                               *
*                                 textmulti Test                                   *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef TEXTDIALOG_H
#define TEXTDIALOG_H

// Mini application object
class TextDialog : public FXDialogBox
 {
  FXDECLARE(TextDialog)
protected:
  FXText*	sample;        // Object being tested
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;

  FXString	textmultialign;
  FXFont*	myfont;
  FXFont*	mainFont;
  FXFontDialog*	fontdlg;
  FXText*	txtResults;
  FXButton*	btnFont;
  FXColorDialog*	colordlg;
  FXSpinner*	spinw;		FXSpinner*	spinh;
  FXSpinner*	spinPosX;	FXSpinner*	spinPosY;
  FXTextField*	txttextmulti;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtTarget;
  FXTextField*	txtSelector;
  FXColor	BaseColor;	FXColor	ShadowColor;
  FXColor	BorderColor;	FXColor	HiliteColor;
  FXColor	BackColor;	FXColor	TextColor;
 FXButton* btnBaseColor;		FXButton* btnShadowColor;
 FXButton* btnBorderColor;	FXButton* btnHiliteColor;
 FXButton* btnBackColor;		FXButton* btnTextColor;
 FXComboBox*	comboiconpos;	FXComboBox*	comboalign;
 FXComboBox*	combolayout;	FXComboBox*	comboframe;
 FXComboBox*	combostyle;
  FXCheckButton*	chkFont;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkColors;
  FXButton*	btnOK;		FXButton*	btnCancel;

private:
  TextDialog(){}
public:
  enum {
    ID_RESULTS=FXDialogBox::ID_LAST,
    ID_TOOLBARGRIP,
    ID_FONT,
    ID_OWNER,
    ID_NAME,
    ID_TARGET,
    ID_SELECTOR,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_LAYOUT,
    ID_DECLARE,
    ID_FONT_DECLARE,
    ID_COLOR_DECLARE,
    ID_TEXT_COLOR,
    };
public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdText(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdTextColor(FXObject*,FXSelector,void*);

public:
  TextDialog(FXWindow* owner);
   virtual ~TextDialog();
  };

#endif
