 /********************************************************************************
*                                                                               *
*                               Generator                                *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "vars.h"
#include "icons.h"
#include <stdio.h>
#include <stdlib.h>

/*******************************************************************************/

// Mini application object
class GenWindow : public FXMainWindow
{
	FXDECLARE(GenWindow)

	protected:
		FXMenubar*	menubar;
		FXTabBook*	tabbook;
		FXTabItem*	tab1;
		FXTabItem*	tab2;
		FXTabItem*	tab3;
		FXTabItem*	tab4;
		FXTabItem*	tab5;
		FXTabItem*	tab6;
		FXMDIChild*	mdiPro;
		FXMatrix*	toolctrl;
		FXToolbar*	mainTools;
		FXToolbar*	toolbox;
		FXMDIClient*	mdiclient;
		FXMDIMenu*	mdimenu;
		FXGIFIcon*	mdiicon;
		FXMenuPane*	filemenu;
		FXMenuPane*	windowmenu;
		FXMenuPane*	helpmenu;
		FXFont*		mainFont;


protected:
  GenWindow(){}		
  
public:
  
  // We define additional ID's, starting from the last one used by the base class+1.
  // This way, we know the ID's are all unique for this particular target.
    enum {
    ID_ABOUT=FXMainWindow::ID_LAST,
	ID_NEW,
	ID_OPEN,
	ID_SAVE,
	ID_SAVEAS,
	ID_CUT,
	ID_COPY,
	ID_PASTE,
	ID_PRINT,
	ID_CREATE_MENUS,
	ID_CREATE_MATRIX,
	ID_CREATE_BUTTON,
	ID_CREATE_ARROWBUTTON,
	ID_CREATE_CHECKBUTTON,
	ID_CREATE_LABEL,
	ID_CREATE_TEXTFIELD,
	ID_CREATE_COMBO,
	ID_CREATE_MULTILINE,
	ID_CREATE_RADIO,
	ID_CREATE_SPINNER,
	ID_CREATE_LISTBOX,
	ID_CODE,
	ID_DECLARE,
	ID_FONT_DECLARE,
	ID_TOOLBAR_STYLE,
	    ID_TEXT,                            // IDs for properties
	    ID_ARROW_DIR,
	    ID_TARGET,
	    ID_COLS,
	    ID_FONT,
	    ID_WIDTH,
	    ID_HEIGHT,
	    ID_POSX,
	    ID_POSY,
	    ID_OWNER,
	    ID_NAME,
	    ID_TOOLTIP,
	    ID_ICONPOS,
	    ID_ALIGN,
	    ID_LAYOUT,
	    ID_FRAME,
	    ID_ICON,
	    ID_TEXT_COLOR,
	    ID_BASE_COLOR,
	    ID_HILITE_COLOR,
	    ID_SHADOW_COLOR,
	    ID_BORDER_COLOR,
	    ID_BACK_COLOR,
	    ID_RESULTS,
	    ID_MTX_STYLE,
    ID_APPNAME,
    ID_APPVENDOR,
    ID_CLASS_NAME,
    ID_CLASS_TYPE,
    ID_VARS,
    ID_ENUMS,
    ID_METHODS,
    ID_ADD_VAR,
    ID_ADD_ENUM,
    ID_ADD_METHOD,
    ID_REMOVE_VAR,
    ID_REMOVE_ENUM,
    ID_REMOVE_METHOD,
    ID_MAINRESULTS,
    ID_TOOLBAR,
    ID_STATUS_BAR,
    ID_TOOLBOX,
    ID_TIP,
    ID_VAR_TYPE
};
    
  // Message handlers
  long onCmdAbout(FXObject*,FXSelector,void*);
  long onCmdNew(FXObject*,FXSelector,void*);
  long onCmdCreateButton(FXObject*,FXSelector,void*);
  long onCmdCreateLabel(FXObject*,FXSelector,void*);
  long onCmdCreateTextField(FXObject*,FXSelector,void*);
  long onCmdCreateCombo(FXObject*,FXSelector,void*);
  long onCmdCreateMulti(FXObject*,FXSelector,void*);
  long onCmdCreateRadio(FXObject*,FXSelector,void*);
  long onCmdCreateSpinner(FXObject*,FXSelector,void*);
  long onCmdCreateListbox(FXObject*,FXSelector,void*);
  long onCmdCreateMain(FXObject*,FXSelector,void*);
  long onCmdCreateMenus(FXObject*,FXSelector,void*);
  long onCmdCreateMatrix(FXObject*,FXSelector,void*);
  long onCmdCreateCheckbutton(FXObject*,FXSelector,void*);
  long onCmdCreateArrowbutton(FXObject*,FXSelector,void*);
  //properties
  long onCmdText(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdIconPos(FXObject*,FXSelector,void*);
  long onCmdAlign(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdToolTip(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdIcon(FXObject*,FXSelector,void*);
  long onCmdTextColor(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdMatrixStyle(FXObject*,FXSelector,void*);

  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdVendor(FXObject*,FXSelector,void*);
  long onCmdClassName(FXObject*,FXSelector,void*);
  long onCmdMainRes(FXObject*,FXSelector,void*);
  long onCmdVars(FXObject*,FXSelector,void*);
  long onCmdAddVar(FXObject*,FXSelector,void*);
  long onCmdRemoveVar(FXObject*,FXSelector,void*);
  long onCmdEnums(FXObject*,FXSelector,void*);
  long onCmdAddEnum(FXObject*,FXSelector,void*);
  long onCmdRemoveEnum(FXObject*,FXSelector,void*);
  long onCmdMethods(FXObject*,FXSelector,void*);
  long onCmdAddMethod(FXObject*,FXSelector,void*);
  long onCmdRemoveMethod(FXObject*,FXSelector,void*);
  long onCmdFontMain(FXObject*,FXSelector,void*);
  long onCmdStatusBar(FXObject*,FXSelector,void*);
  long onCmdVarType(FXObject*,FXSelector,void*);
  long onCmdClassType(FXObject*,FXSelector,void*);
  long onCmdToolBar(FXObject*,FXSelector,void*);
  long onCmdToolBox(FXObject*,FXSelector,void*);
  long onCmdToolTipMain(FXObject*,FXSelector,void*);

public:
  GenWindow(FXApp* a);
  virtual void create();
  virtual ~GenWindow();
  };

/*******************************************************************************/

// Map
FXDEFMAP(GenWindow) GenWindowMap[]={
  //________Message_Type____________ID___________________Message_Handler________
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ABOUT,GenWindow::onCmdAbout),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_NEW,GenWindow::onCmdNew),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_BUTTON,GenWindow::onCmdCreateButton),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_LABEL,GenWindow::onCmdCreateLabel),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_TEXTFIELD,GenWindow::onCmdCreateTextField),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_COMBO,GenWindow::onCmdCreateCombo),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_MULTILINE,GenWindow::onCmdCreateMulti),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_RADIO,GenWindow::onCmdCreateRadio),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_SPINNER,GenWindow::onCmdCreateSpinner),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_LISTBOX,GenWindow::onCmdCreateListbox),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_MENUS,GenWindow::onCmdCreateMenus),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_MATRIX,GenWindow::onCmdCreateMatrix),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_CHECKBUTTON,GenWindow::onCmdCreateCheckbutton),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CREATE_ARROWBUTTON,GenWindow::onCmdCreateArrowbutton),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TEXT,GenWindow::onCmdText),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_MTX_STYLE,GenWindow::onCmdMatrixStyle),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TARGET,GenWindow::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_WIDTH,GenWindow::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_HEIGHT,GenWindow::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_POSX,GenWindow::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_POSY,GenWindow::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_FONT,GenWindow::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_RESULTS,GenWindow::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TOOLTIP,GenWindow::onCmdToolTip),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ICONPOS,GenWindow::onCmdIconPos),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ALIGN,GenWindow::onCmdAlign),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_LAYOUT,GenWindow::onCmdLayout),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ICON,GenWindow::onCmdIcon),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_FRAME,GenWindow::onCmdFrame),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TEXT_COLOR,GenWindow::onCmdTextColor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_DECLARE,GenWindow::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_FONT_DECLARE,GenWindow::onCmdFontDeclare),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_BASE_COLOR,GenWindow::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_BORDER_COLOR,GenWindow::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_HILITE_COLOR,GenWindow::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_SHADOW_COLOR,GenWindow::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_BACK_COLOR,GenWindow::onCmdBackColor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_APPNAME,GenWindow::onCmdName),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_APPVENDOR,GenWindow::onCmdVendor),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CLASS_NAME,GenWindow::onCmdClassName),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_MAINRESULTS,GenWindow::onCmdMainRes),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_VARS,GenWindow::onCmdVars),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ADD_VAR,GenWindow::onCmdAddVar),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_REMOVE_VAR,GenWindow::onCmdRemoveVar),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ENUMS,GenWindow::onCmdEnums),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ADD_ENUM,GenWindow::onCmdAddEnum),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_REMOVE_ENUM,GenWindow::onCmdRemoveEnum),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_METHODS,GenWindow::onCmdMethods),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_ADD_METHOD,GenWindow::onCmdAddMethod),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_REMOVE_METHOD,GenWindow::onCmdRemoveMethod),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_FONT,GenWindow::onCmdFontMain),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_STATUS_BAR,GenWindow::onCmdStatusBar),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_VAR_TYPE,GenWindow::onCmdVarType),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_CLASS_TYPE,GenWindow::onCmdClassType),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TOOLBAR,GenWindow::onCmdToolBar),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TOOLBOX,GenWindow::onCmdToolBox),
  FXMAPFUNC(SEL_COMMAND,GenWindow::ID_TIP,GenWindow::onCmdToolTipMain),
};


// Object implementation
FXIMPLEMENT(GenWindow,FXMainWindow,GenWindowMap,ARRAYNUMBER(GenWindowMap))

// Make some windows
GenWindow::GenWindow(FXApp* a):FXMainWindow(a,"Generator",NULL,NULL,DECOR_ALL,0,0,1000,800)
{
	FXMDIChild *mditoolbox;
	FXMDIChild* mdiCode;
	mainFont=new FXFont(getApp(),"grtex",10);
	
	comboicon=new FXGIFIcon(getApp(),ComboBox);
	checkicon=new FXGIFIcon(getApp(),CheckButton);
	buttonicon=new FXGIFIcon(getApp(),DrawnButton);
	textboxicon=new FXGIFIcon(getApp(),TextField);
	multilineicon=new FXGIFIcon(getApp(),CSText);
	spinnericon=new FXGIFIcon(getApp(),SpinBox);
	radioicon=new FXGIFIcon(getApp(),RadioBox);
	listboxicon=new FXGIFIcon(getApp(),List);
	arrowbuttonicon=new FXGIFIcon(getApp(),ArrowButton);
//	mainicon=new FXGIFIcon(getApp(),MainWindowIcon);
	matrixicon=new FXGIFIcon(getApp(),Matrix);
	menuicon=new FXGIFIcon(getApp(),MenuBar);
	labelicon=new FXGIFIcon(getApp(),Label);
	createicon=new FXGIFIcon(getApp(),creation);
	//icons for main toolbar
	copyicon=new FXGIFIcon(getApp(),copy);
              newicon=new FXGIFIcon(getApp(),new_gif);
	openicon=new FXGIFIcon(getApp(),open_gif);
	saveicon=new FXGIFIcon(getApp(),save_gif);
	saveasicon=new FXGIFIcon(getApp(),saveas_gif);
	cuticon=new FXGIFIcon(getApp(),cut_gif);
	pasteicon=new FXGIFIcon(getApp(),paste_gif);
	printicon=new FXGIFIcon(getApp(),print_gif);
	
	codeicon=new FXGIFIcon(getApp(),code);
	propertiesicon=new FXGIFIcon(getApp(),properties);
	toolboxicon=new FXGIFIcon(getApp(),toolbox);
	
	// Tooltip
	FXTooltip* tooltip= new FXTooltip(getApp());
	tooltip->setFont(mainFont);
	
	// Menubar
	menubar=new FXMenubar(this,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);

	//Main Toolbar
	FXToolbarShell* dragshell1=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mainTools=new FXToolbar(this,dragshell1,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
             	new FXToolbarGrip(mainTools,this,ID_TOOLBARGRIP);
              FXButton* btnNew=new FXButton(mainTools,"\tNew Project",newicon,this,ID_NEW,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnOpen=new FXButton(mainTools,"\tOpen Project",openicon,this,ID_OPEN,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnSave=new FXButton(mainTools,"\tSave Project",saveicon,this,ID_SAVE,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnSaveAs=new FXButton(mainTools,"\tSave As ...",saveasicon,this,ID_SAVEAS,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCut=new FXButton(mainTools,"\tCut",cuticon,this,ID_CUT,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCopy=new FXButton(mainTools,"\tCopy",copyicon,this,ID_COPY,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnPaste=new FXButton(mainTools,"\tPaste",pasteicon,this,ID_PASTE,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnPrint=new FXButton(mainTools,"\tPrint Code",printicon,this,ID_PRINT,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	
	// Toolbox
	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	toolbox=new FXToolbar(this,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
             	new FXToolbarGrip(toolbox,this,ID_TOOLBARGRIP);
	FXButton* btnCreate_Menus=new FXButton(toolbox,"\tMenu Creator",menuicon,this,ID_CREATE_MENUS,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Matrix=new FXButton(toolbox,"\tMatrix Creator",matrixicon,this,ID_CREATE_MATRIX,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Button=new FXButton(toolbox,"\tButton Creator",buttonicon,this,ID_CREATE_BUTTON,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_ArrowButton=new FXButton(toolbox,"\tArrow Button Creator",arrowbuttonicon,this,ID_CREATE_ARROWBUTTON,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_CheckButton=new FXButton(toolbox,"\tCheck Button Creator",checkicon,this,ID_CREATE_CHECKBUTTON,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Label=new FXButton(toolbox,"\tLabel Creator",labelicon,this,ID_CREATE_LABEL,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Combo=new FXButton(toolbox,"\tComboBox Creator",comboicon,this,ID_CREATE_COMBO,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Text=new FXButton(toolbox,"\tText Field Creator",textboxicon,this,ID_CREATE_TEXTFIELD,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Spinner=new FXButton(toolbox,"\tSpinner Creator",spinnericon,this,ID_CREATE_SPINNER,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Radio=new FXButton(toolbox,"\tRadio button Creator",radioicon,this,ID_CREATE_RADIO,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_MlineTxt=new FXButton(toolbox,"\tText Multi line Creator",multilineicon,this,ID_CREATE_MULTILINE,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);
	FXButton* btnCreate_Listbox=new FXButton(toolbox,"\tList Box Creator",listboxicon,this,ID_CREATE_LISTBOX,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,1,1,32,32);

	// Status bar
	new FXStatusbar(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|STATUSBAR_WITH_DRAGCORNER);
  
	// MDI Client
	mdiclient=new FXMDIClient(this,LAYOUT_FILL_X|LAYOUT_FILL_Y);
  
	// Icon for MDI Child
	mdiicon=new FXGIFIcon(getApp(),CommandDialog);

	// Make MDI Menu
	mdimenu=new FXMDIMenu(this,mdiclient);
	             		
	new FXMDIWindowButton(menubar,mdiclient,FXMDIClient::ID_MDI_MENUWINDOW,LAYOUT_LEFT);
	new FXMDIDeleteButton(menubar,mdiclient,FXMDIClient::ID_MDI_MENUCLOSE,FRAME_RAISED|LAYOUT_RIGHT);
	new FXMDIRestoreButton(menubar,mdiclient,FXMDIClient::ID_MDI_MENURESTORE,FRAME_RAISED|LAYOUT_RIGHT);
	new FXMDIMinimizeButton(menubar,mdiclient,FXMDIClient::ID_MDI_MENUMINIMIZE,FRAME_RAISED|LAYOUT_RIGHT);

	//properties window and Properties
	mdiPro=new FXMDIChild(mdiclient,"Properties",propertiesicon,mdimenu,LAYOUT_FIX_X|LAYOUT_FIX_Y,110,5,410,680);
              // Controls on right
	tabbook=new FXTabBook(mdiPro,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_RIGHT);
	 tab1=new FXTabItem(tabbook,"&Variables",NULL);
	 FXMatrix* mtxEnums=new FXMatrix(tabbook,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	  cmbVarTypes=new FXComboBox(mtxEnums,11,10,this,ID_VAR_TYPE,COMBOBOX_INSERT_LAST||FRAME_SUNKEN|LAYOUT_SIDE_TOP);
	  cmbVarTypes->setFont(mainFont);
	  for (int i=0; i<20; i++) cmbVarTypes->appendItem(VarTypesStr[i]);
	  cmbVarTypes->setCurrentItem(0);
   	  txtAddVar=new FXTextField(mtxEnums,15,this,ID_ADD_VAR,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
	  txtAddVar->setFont(mainFont);
   	  lstVars=new FXList(mtxEnums,10,this,ID_VARS,LISTBOX_NORMAL|LAYOUT_FILL_X);
	  lstVars->appendItem("FXTextField* Test");
	  lstVars->setFont(mainFont);
	  FXButton* btnRemoveVar=new FXButton(mtxEnums,"Remove\tRemove line from var list",NULL,this,ID_REMOVE_VAR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
	  btnRemoveVar->setFont(mainFont);
	
	 tab2=new FXTabItem(tabbook,"&Enumerations",NULL);
	 FXMatrix* mtxVars=new FXMatrix(tabbook,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	   FXLabel* lblAddEnum=new FXLabel(mtxVars,"Add Enum\tAdd New Enum",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,126,25);
	   lblAddEnum->setFont(mainFont);
	   txtAddEnum=new FXTextField(mtxVars,20,this,ID_ADD_ENUM,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
	   txtAddEnum->setFont(mainFont);
	   lstEnums=new FXList(mtxVars,10,this,ID_ENUMS,LISTBOX_NORMAL|LAYOUT_FILL_X);
	   lstEnums->appendItem("ID_NEW");
	   lstEnums->setFont(mainFont);
	   FXButton* btnRemoveEnum=new FXButton(mtxVars,"Remove\tRemove Line from enum List",NULL,this,ID_REMOVE_ENUM,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
	   btnRemoveEnum->setFont(mainFont);
	
	   tab3=new FXTabItem(tabbook,"M&ethods",NULL);
	   FXMatrix* mtxMethods=new FXMatrix(tabbook,1,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
                  FXLabel* lblAddMethod=new FXLabel(mtxMethods,"Add Method\tAdd New Method",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,126,25);
	    lblAddMethod->setFont(mainFont);
	    txtAddMethod=new FXTextField(mtxMethods,20,this,ID_ADD_METHOD,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
	    txtAddMethod->setFont(mainFont);
	    lstMethods=new FXList(mtxMethods,10,this,ID_METHODS,LISTBOX_NORMAL|LAYOUT_FILL_X);
	    lstMethods->appendItem("onCmd...");
	    lstMethods->setFont(mainFont);
	    FXButton* btnRemoveMethod=new FXButton(mtxMethods,"Remove\tRemove line from method list",NULL,this,ID_REMOVE_METHOD,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,100,25);
	    btnRemoveMethod->setFont(mainFont);
	
	 tab4=new FXTabItem(tabbook,"&Main",NULL);
	 FXMatrix* mtxMain=new FXMatrix(tabbook,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	  FXLabel *lblmName=new FXLabel(mtxMain,"&Name:\tApplication name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblmName->setFont(mainFont);
	  txtAppName=new FXTextField(mtxMain,15,this,ID_APPNAME,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtAppName->setFont(mainFont);

	  FXLabel *lblVendor=new FXLabel(mtxMain,"&Editor:\tApplication Editor",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblVendor->setFont(mainFont);
	  txtAppVendor=new FXTextField(mtxMain,15,this,ID_APPVENDOR,LAYOUT_LEFT|FRAME_SUNKEN|JUSTIFY_LEFT);
	  txtAppVendor->setFont(mainFont);

	  FXLabel *lblClass=new FXLabel(mtxMain,"&Class name:\tApplication class name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblClass->setFont(mainFont);
	  txtClassName=new FXTextField(mtxMain,15,this,ID_CLASS_NAME,LAYOUT_LEFT|FRAME_SUNKEN|JUSTIFY_LEFT);
	  txtClassName->setFont(mainFont);
	
	  FXLabel *lblClassType=new FXLabel(mtxMain,"&Base Class:\tParent class name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblClassType->setFont(mainFont);
	  cmbClassTypes=new FXComboBox(mtxMain,11,10,this,ID_CLASS_TYPE,COMBOBOX_INSERT_LAST||FRAME_SUNKEN|LAYOUT_SIDE_TOP);
	  cmbClassTypes->setFont(mainFont);
	  for (int i=0; i<20; i++) cmbClassTypes->appendItem(VarTypesStr[i]);
	  cmbClassTypes->setCurrentItem(0);

	  //font
	  btnFont=new FXButton(mtxMain,"&Font",NULL,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
	  btnFont->setFont(mainFont);
	  myfont=new FXFont(getApp(),"grtex",12);
	
	  //Status Bar
	  chkStatusBar=new FXCheckButton(mtxMain,"Status Bar",this,ID_STATUS_BAR,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkStatusBar->setFont(mainFont);chkStatusBar->setFont(mainFont);chkStatusBar->setBackColor(FXRGBA(0,255,255,255));
	  chkStatusBar->setShadowColor(FXRGBA(126,126,126,255));
 	  chkStatusBar->setBorderColor(FXRGBA(0,0,0,255));
	  chkStatusBar->setBaseColor(FXRGBA(192,192,192,255));
	  chkStatusBar->setHiliteColor(FXRGBA(255,255,255,255));
	  chkStatusBar->setTextColor(FXRGBA(0,0,0,255));

	  //  chkStatusBar=new FXCheckButton(controls,"Status Bar",this,ID_STATUS_BAR,JUSTIFY_NORMAL|ICON_AFTER_TEXT);
	  chkToolBar=new FXCheckButton(mtxMain,"Tool Bar",this,ID_TOOLBAR,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkToolBar->setFont(mainFont);chkToolBar->setFont(mainFont);chkToolBar->setBackColor(FXRGBA(0,255,255,255));
	  chkToolBar->setShadowColor(FXRGBA(126,126,126,255));
 	  chkToolBar->setBorderColor(FXRGBA(0,0,0,255));
	  chkToolBar->setBaseColor(FXRGBA(192,192,192,255));
	  chkToolBar->setHiliteColor(FXRGBA(255,255,255,255));
	  chkToolBar->setTextColor(FXRGBA(0,0,0,255));

	  //  chkToolBar=new FXCheckButton(controls,"Tool Bar",this,ID_TOOLBAR,JUSTIFY_NORMAL|ICON_AFTER_TEXT);
	  chkToolTip=new FXCheckButton(mtxMain,"Tool Tips",this,ID_TIP,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkToolTip->setFont(mainFont);chkToolTip->setFont(mainFont);chkToolTip->setBackColor(FXRGBA(0,255,255,255));
	  chkToolTip->setShadowColor(FXRGBA(126,126,126,255));
	  chkToolTip->setBorderColor(FXRGBA(0,0,0,255));
	  chkToolTip->setBaseColor(FXRGBA(192,192,192,255));
	  chkToolTip->setHiliteColor(FXRGBA(255,255,255,255));
	  chkToolTip->setTextColor(FXRGBA(0,0,0,255));

    	  //     widgets
	  FXButton* btnCreateM=new FXButton(mtxMain,"\tCreate commands and\ncopy them into code window",createicon,this,ID_MAINRESULTS,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
	  btnCreateM->setFont(mainFont);
  	  	
	  tab5=new FXTabItem(tabbook,"&Widget Properties",NULL);
	  controls=new FXMatrix(tabbook,4,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	  chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkDeclare->setFont(mainFont);
	  chkFont=new FXCheckButton(controls,"Get the main Font",this,ID_FONT_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkFont->setFont(mainFont);

	  //  
	  FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblName->setFont(mainFont);
	  txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtName->setFont(mainFont);
	
	   //
	  FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblOwner->setFont(mainFont);
	  txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtOwner->setFont(mainFont);

	  // 
	  FXLabel *lblText=new FXLabel(controls,"&Text:\tText on Object",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblText->setFont(mainFont);
	  txtLabel=new FXTextField(controls,15,this,ID_TEXT,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtLabel->setFont(mainFont);
	
	  //  arrowbuttons
	  FXLabel *lbldir=new FXLabel(controls,"&Arrow Direction:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbldir->setFont(mainFont);
	  arrowdirection=new FXComboBox(controls,15,5,this,ID_ARROW_DIR,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<4; i++){  arrowdirection->appendItem(dirArrow[i]);         }
	  arrowdirection->setCurrentItem(0);
	
	  // - spinner
	  FXLabel* lblCols=new FXLabel(controls,"&Columns:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblCols->setFont(mainFont);
	  spinCols=new FXSpinner(controls,6,this,ID_COLS,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinCols->setFont(mainFont);
	  spinCols->setRange(1,10);

	  //Matrix Style
	  FXLabel *lblStyle=new FXLabel(controls,"&Style:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblStyle->setFont(mainFont);
	  cmbMatrixStyle=new FXComboBox(controls,15,5,this,ID_MTX_STYLE,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<2; i++){  cmbMatrixStyle->appendItem(strMtxStyle[i]);         }
	  cmbMatrixStyle->setCurrentItem(0);
              	  	
	  // 
	  FXLabel *lblTooltip=new FXLabel(controls,"&Tool Tip:\tTip when the mouse is over",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblTooltip->setFont(mainFont);
	  txtTooltip=new FXTextField(controls,15,this,ID_TOOLTIP,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtTooltip->setFont(mainFont);
	
	  //
	  FXLabel *lblTarget=new FXLabel(controls,"&Target,ID:\tTarget,ID",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblTarget->setFont(mainFont);
	  txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtTarget->setFont(mainFont);
	
	   //
	  FXLabel *lblIcon=new FXLabel(controls,"&Icon:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblIcon->setFont(mainFont);
	  txtIcon=new FXTextField(controls,15,this,ID_ICON,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtIcon->setFont(mainFont);

	  // 
	  FXLabel *lbliconpos=new FXLabel(controls,"&Icon Position:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbliconpos->setFont(mainFont);
	  comboiconpos=new FXComboBox(controls,11,5,this,ID_ICONPOS,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<5; i++){  comboiconpos->appendItem(striconpos[i]);         }
	  comboiconpos->setCurrentItem(0);

	  //
	  FXLabel *lblalign=new FXLabel(controls,"&Alignment:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblalign->setFont(mainFont);
	  comboalign=new FXComboBox(controls,15,5,this,ID_ALIGN,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<8; i++){  comboalign->appendItem(stralign[i]);         }
	  comboalign->setCurrentItem(0);
	
	  //  
	  FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbllayout->setFont(mainFont);
	  combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
	  combolayout->setCurrentItem(0);

	  //
	  FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblframe->setFont(mainFont);
	  comboframe=new FXComboBox(controls,15,5,this,ID_FRAME,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
	  comboframe->setCurrentItem(0);

	  // 
	  FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblWidth->setFont(mainFont);
	  spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinw->setFont(mainFont);
	  spinw->setRange(1,500);

	  // 
	  FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblHeight->setFont(mainFont);
	  spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinh->setFont(mainFont);
	  spinh->setRange(1,400);

	  // 
	  FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosX->setFont(mainFont);
	  spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosX->setFont(mainFont);
	  spinPosX->setRange(1,1000);
	
	  // 
	  FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosY->setFont(mainFont);
	  spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosY->setFont(mainFont);
	  spinPosY->setRange(1,1000);
	
	  //
	  btnFont=new FXButton(controls,"&Font",NULL,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
	  btnFont->setFont(mainFont);
	  myfont=new FXFont(getApp(),"grtex",12);
	
	  //
	  btnTextColor=new FXButton(controls,"Text Color\tChange the color of the text",NULL,this,ID_TEXT_COLOR,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
	  btnTextColor->setFont(mainFont);

	  // 
	  btnBaseColor=new FXButton(controls,"BS\tBase color",NULL,this,ID_BASE_COLOR,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
	  btnBaseColor->setFont(mainFont);
	  btnBaseColor->setTextColor(FXRGBA(0,0,200,255));	

	  // HIlite
	  btnHiliteColor=new FXButton(controls,"HT\tHilite color",txtColorIcon,this,ID_HILITE_COLOR,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
	  btnHiliteColor->setFont(mainFont);
	  btnHiliteColor->setTextColor(FXRGBA(0,0,255,255));

	  // 
	  btnBorderColor=new FXButton(controls,"Bd\tBorder color",txtColorIcon,this,ID_BORDER_COLOR,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
	  btnBorderColor->setFont(mainFont);
	  btnBorderColor->setTextColor(FXRGBA(0,0,255,255));

	  // 
	  btnShadowColor=new FXButton(controls,"Sd\tShadow color",txtColorIcon,this,ID_SHADOW_COLOR,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
	  btnShadowColor->setFont(mainFont);
	  btnShadowColor->setTextColor(FXRGBA(0,0,255,255));

	  // 
	  btnBackColor=new FXButton(controls,"Bc\tBack color",txtColorIcon,this,ID_BACK_COLOR,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
	  btnBackColor->setFont(mainFont);
	  btnBackColor->setTextColor(FXRGBA(0,0,255,255));
	
	  //     widgets
	  FXButton* btnCreateW=new FXButton(controls,"\tCreate commands and\ncopy them into code window",createicon,this,ID_RESULTS,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
	  btnCreateW->setFont(mainFont);


	  tab6=new FXTabItem(tabbook,"&Lists",NULL);
	  FXMatrix* mtxLists=new FXMatrix(tabbook,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	  	
	//text Window
	mdiCode=new FXMDIChild(mdiclient,"Code",codeicon,mdimenu,LAYOUT_FIX_X|LAYOUT_FIX_Y,530,5,500,500);
	mtxtCode=new FXText(mdiCode,this,ID_CODE,LAYOUT_FILL_X|LAYOUT_FILL_Y);
	mtxtCode->setFont(mainFont);

	// File menu
	filemenu=new FXMenuPane(this);
	new FXMenuCommand(filemenu,"&New\tCtl-N\tCreate new document.",NULL,this,ID_NEW);
	new FXMenuCommand(filemenu,"&Open\tCtl-O\tOpen document.");
	new FXMenuCommand(filemenu,"&Quit\tCtl-Q\tQuit application.",NULL,getApp(),FXApp::ID_QUIT,0);
	new FXMenuTitle(menubar,"&File",NULL,filemenu);
    
	// Window menu
	windowmenu=new FXMenuPane(this);
	new FXMenuCommand(windowmenu,"Tile &Horizontally",NULL,mdiclient,FXMDIClient::ID_MDI_TILEHORIZONTAL);
	new FXMenuCommand(windowmenu,"Tile &Vertically",NULL,mdiclient,FXMDIClient::ID_MDI_TILEVERTICAL);
	new FXMenuCommand(windowmenu,"C&ascade",NULL,mdiclient,FXMDIClient::ID_MDI_CASCADE);
	new FXMenuCommand(windowmenu,"&Close",NULL,mdiclient,FXMDIClient::ID_MDI_CLOSE);
	new FXMenuCommand(windowmenu,"Close &All",NULL,mdiclient,FXMDIClient::ID_CLOSE_ALL_DOCUMENTS);
	FXMenuSeparator* sep1=new FXMenuSeparator(windowmenu);
	sep1->setTarget(mdiclient);
	sep1->setSelector(FXMDIClient::ID_MDI_ANY);
	new FXMenuCommand(windowmenu,NULL,NULL,mdiclient,FXMDIClient::ID_MDI_1);
	new FXMenuCommand(windowmenu,NULL,NULL,mdiclient,FXMDIClient::ID_MDI_2);
	new FXMenuCommand(windowmenu,NULL,NULL,mdiclient,FXMDIClient::ID_MDI_3);
	new FXMenuCommand(windowmenu,NULL,NULL,mdiclient,FXMDIClient::ID_MDI_4);
	new FXMenuTitle(menubar,"&Window",NULL,windowmenu);
  
	// Help menu
	helpmenu=new FXMenuPane(this);
	new FXMenuCommand(helpmenu,"&About FOX...",NULL,this,ID_ABOUT,0);
	new FXMenuTitle(menubar,"&Help",NULL,helpmenu,LAYOUT_RIGHT);
}


// Clean up  
// Clean up
GenWindow::~GenWindow(){
  delete filemenu;
  delete windowmenu;
  delete helpmenu;
  }

// About
long GenWindow::onCmdAbout(FXObject*,FXSelector,void*){
  FXMessageBox::information(this,MBOX_OK,"About MDI Test","Test of the FOX MDI Widgets\nWritten by Jeroen van der Zijp");
  return 1;
  }

 // New
long GenWindow::onCmdNew(FXObject*,FXSelector,void*)
{
  FXMDIChild* mdiCode=new FXMDIChild(mdiclient,"Code",mdiicon,mdimenu,LAYOUT_FIX_X|LAYOUT_FIX_Y,300,10,600,500);
  FXText* mtxtCode=new FXText(mdiCode,this,ID_CODE,LAYOUT_FILL_X|LAYOUT_FILL_Y);
  FXFont* mtxtCodeFont=new FXFont(getApp(),"grtex",12);
  mtxtCode->setFont(mtxtCodeFont);
  mdiCode->create();
  return 1;
  }

// Start
void GenWindow::create()
{
  FXMainWindow::create();
  show();
}

long GenWindow::onCmdCreateButton(FXObject*,FXSelector,void*)
{
	HasText=1;
	ObjType=1;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->enable();
              arrowdirection->disable();
              spinCols->disable();
              cmbMatrixStyle->disable();
              txtTooltip->enable();
              txtTarget->enable();
              txtIcon->enable();
	comboiconpos->enable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnTextColor->enable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();
	btnFont->enable();
	
	txtName->setText("btn");
	DeclareStr="FXButton*";
	newObjectStr="=new FXButton(";	
	return 1;
}

long GenWindow::onCmdCreateArrowbutton(FXObject*,FXSelector,void*)
{
	HasText=0;
	ObjType=2;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->disable();
              arrowdirection->enable();
              spinCols->disable();
              cmbMatrixStyle->disable();
              txtTooltip->disable();
              txtTarget->enable();
              txtIcon->disable();
	comboiconpos->disable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnTextColor->disable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();
	btnFont->disable();
	
              DeclareStr="FXArrowButton* ";
              txtName->setText("arbtn");
              newObjectStr="=new FXArrowButton(";
	return 1;
}

long GenWindow::onCmdCreateCheckbutton(FXObject*,FXSelector,void*)
{
	ObjType=3;
	HasText=1;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->enable();
              arrowdirection->disable();
              spinCols->disable();
              cmbMatrixStyle->disable();
              txtTooltip->enable();
              txtTarget->enable();
              txtIcon->disable();
	comboiconpos->enable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->enable();
	btnTextColor->enable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();
	
	DeclareStr="FXCheckButton* ";
	txtName->setText("chk");
	newObjectStr="new FXCheckButton(";
	return 1;
}

long GenWindow::onCmdCreateLabel(FXObject*,FXSelector,void*)
{
	HasText=1;
	ObjType=4;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->enable();
              arrowdirection->disable();
              spinCols->disable();
              cmbMatrixStyle->disable();
              txtTooltip->enable();
              txtTarget->disable();
              txtIcon->enable();
	comboiconpos->enable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->enable();
	btnTextColor->enable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();
              	
	txtName->setText("lbl");
	DeclareStr="FXLabel*";
	newObjectStr="=new FXLabel(";
	return 1;
}

long GenWindow::onCmdCreateCombo(FXObject*,FXSelector,void*)
{
	system("/root/fox-0.99.160/mytests/combobox");
	return 1;
}

long GenWindow::onCmdCreateMulti(FXObject*,FXSelector,void*)
{
	HasText=1;
	ObjType=8;

	txtName->enable();
	txtOwner->enable();
	txtLabel->disable();
              arrowdirection->disable();
              spinCols->enable();
              cmbMatrixStyle->enable();
              txtTooltip->disable();
              txtTarget->enable();
              txtIcon->disable();
	comboiconpos->disable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->enable();
	btnTextColor->disable();
	btnBaseColor->disable();
	btnHiliteColor->disable();
	btnBorderColor->disable();
	btnShadowColor->disable();
	btnBackColor->disable();
	
	txtName->setText("mtxt");
	DeclareStr="FXText* ";
	newObjectStr="=new FXText(";
	return 1;
}

long GenWindow::onCmdCreateRadio(FXObject*,FXSelector,void*)
{
	HasText=1;
	ObjType=5;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->disable();
              arrowdirection->disable();
              spinCols->disable();
              cmbMatrixStyle->enable();
              txtTooltip->enable();
              txtTarget->enable();
              txtIcon->disable();
	comboiconpos->enable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->enable();
	btnTextColor->enable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();
		
	txtName->setText("rdio");
	newObjectStr="new FXRadioButton(";
	DeclareStr="FXRadioButton* ";
	return 1;
}

long GenWindow::onCmdCreateListbox(FXObject*,FXSelector,void*)
{
	system("/root/fox-0.99.160/mytests/listbox");
	return 1;
}

long GenWindow::onCmdCreateSpinner(FXObject*,FXSelector,void*)
{
	HasText=0;
	ObjType=6;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->disable();
              arrowdirection->disable();
              spinCols->enable();
              cmbMatrixStyle->enable();
              txtTooltip->enable();
              txtTarget->enable();
              txtIcon->disable();
	comboiconpos->disable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->enable();
	btnTextColor->enable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();
	
	txtName->setText("spn");
	DeclareStr="FXSpinner* ";
	newObjectStr="=new FXSpinner(";
	return 1;
}

long GenWindow::onCmdCreateTextField(FXObject*,FXSelector,void*)
{
	HasText=1;
	ObjType=7;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->disable();
              arrowdirection->disable();
              spinCols->enable();
              cmbMatrixStyle->enable();
              txtTooltip->enable();
              txtTarget->enable();
              txtIcon->disable();
	comboiconpos->disable();
	comboalign->enable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->enable();
	btnTextColor->enable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->enable();

		
	txtName->setText("txt");
	DeclareStr="FXTextField* ";
	newObjectStr="=new FXTextField(";
	return 1;
}

long GenWindow::onCmdCreateMenus(FXObject*,FXSelector,void*)
{
	system("/root/fox-0.99.160/mytests/menus");
	return 1;
}

long GenWindow::onCmdCreateMatrix(FXObject*,FXSelector,void*)
{
              HasText=0;
	ObjType=9;
	
	txtName->enable();
	txtOwner->enable();
	txtLabel->disable();
              arrowdirection->disable();
              spinCols->enable();
              cmbMatrixStyle->enable();
              txtTooltip->disable();
              txtTarget->disable();
              txtIcon->disable();
	comboiconpos->disable();
	comboalign->disable();
	combolayout->enable();
	comboframe->enable();
	spinw->enable();
	spinh->enable();
	spinPosX->enable();
	spinPosY->enable();
	btnFont->disable();
	btnTextColor->disable();
	btnBaseColor->enable();
	btnHiliteColor->enable();
	btnBorderColor->enable();
	btnShadowColor->enable();
	btnBackColor->disable();
	
	txtName->setText("mtx");
	DeclareStr="FXMatrix* ";
	newObjectStr="=new FXMatrix(";
	return 1;
}

long GenWindow::onCmdResults(FXObject*,FXSelector,void*)
{             FXString Resultstxt;
              FXString strFont;
	FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString TextColorStr;
	FXString*	SumRes;
	
	FXString TipStr;
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjTarget;
	FXString ObjTip;
	FXString ObjIcon;
	FXString ObjIconPos;
	FXString ObjAlign;
	FXString ObjLayout;
	FXString ObjFrame;
	FXString ObjCols;
	
	TipStr="";
	ObjCols="";
	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjText=ec+txtLabel->getText()+"\\t";
	ObjTarget=txtTarget->getText()+",";
	ObjTip=txtTooltip->getText()+ec+",";
	ObjIcon=txtIcon->getText()+",";
	ObjIconPos=comboiconpos->getText()+"|";
	ObjAlign=comboalign->getText()+"|";
	ObjLayout=combolayout->getText()+"|";
	ObjFrame=comboframe->getText();
	
	strFont="FXFont* "+txtName->getText()+"Font=new FXFont(getApp(),"+
		ec+myfont->getName()+ec+","+
		FXStringVal(myfont->getSize()/10)+");\n"+
		txtName->getText()+"->setFont("+txtName->getText()+"Font);\n";
	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkFont->getCheck())==TRUE) strFont=txtName->getText()+"->setFont(mainFont);";
	if (HasText==0)
	{	ObjText="";
		ObjTip="";
	}
	if (ObjType==2)                                 // is arrow button?
	{
		ObjFrame=ObjFrame+"|"+arrowdirection->getText();
		ObjIcon="";
		ObjIconPos="";
	}
	if ((ObjType==3) || (ObjType==5) || (ObjType==6) || (ObjType==7))            // check, radio, spinner, textfield
	{
		ObjIcon="";
		ObjTip="";
		TipStr=txtName->getText()+"->setTipText("+txtTooltip->getText()+");\n";
	}
	if ((ObjType==4) || (ObjType==9)) ObjTarget="";
	if (ObjType==9)           // is matrix?
	{
		ObjIcon="";
		ObjIconPos="";
		ObjAlign="";
	}
	if ((ObjType=6) || (ObjType==7)) ObjCols=FXStringVal(spinCols->getValue(),10)+",";
	Resultstxt=DeclareStr+
			ObjName+
			newObjectStr+
			ObjOwner+
			ObjCols+
			ObjText+
			ObjTip+				
			ObjIcon+
			ObjTarget+
			ObjIconPos+
			ObjAlign+
			ObjLayout+
			ObjFrame+","+
			FXStringVal(spinPosX->getValue(),10)+","+
			FXStringVal(spinPosY->getValue(),10)+","+
			FXStringVal(spinw->getValue(),10)+","+
			FXStringVal(spinh->getValue(),10)+");\n";
	BackColorStr=txtName->getText()+
		"->setBackColor(FXRGBA("+
		FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+
		FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=txtName->getText()+
		"->setBaseColor(FXRGBA("+
		FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+
		FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=txtName->getText()+
		"->setShadowColor(FXRGBA("+
		FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+
		FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=txtName->getText()+
		"->setBorderColor(FXRGBA("+
		FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+
		FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=txtName->getText()+
		"->setHiliteColor(FXRGBA("+
		FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+
		FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	TextColorStr=txtName->getText()+
		"->setTextColor(FXRGBA("+
		FXStringVal(FXREDVAL(TextColor))+","+
		FXStringVal(FXGREENVAL(TextColor))+","+
		FXStringVal(FXBLUEVAL(TextColor))+","+
		FXStringVal(FXALPHAVAL(TextColor))+"));\n";
	if (ObjType==8)
	{
		TextColorStr="";
		HiliteColorStr="";
		BorderColorStr="";
		ShadowColorStr="";
		BaseColorStr="";
		BackColorStr="";
	}
 	Total=Resultstxt+
 		strFont+
 		BackColorStr+
 		ShadowColorStr+
 		BorderColorStr+
 		BaseColorStr+
 		HiliteColorStr+
 		TextColorStr+
 		TipStr;
		
	SumRes=&Total;
	mtxtCode->insertText(mtxtCode->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);
	return 1;
}

long GenWindow::onCmdMatrixStyle(FXObject*,FXSelector,void*)
{
	FXuint style; //=matrix->getMatrixStyle();
	style=cmbMatrixStyle->getCurrentItem();
	if ((cmbMatrixStyle->getText())=="MATRIX_BY_COLUMNS")
	{
		style|=MATRIX_BY_COLUMNS;
	}
	else if  ((cmbMatrixStyle->getText())=="MATRIX_BY_ROWS")
	{
		style|=MATRIX_BY_ROWS;
	}
//	matrix->setMatrixStyle(style);
	return 1;
}

long GenWindow::onCmdTarget(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdIconPos(FXObject*,FXSelector,void*)
{
	FXuint IconPos; //=sample->getIconPosition();
	IconPos=comboiconpos->getCurrentItem();
	if ((comboiconpos->getText())=="ICON_BEFORE_TEXT")
	{
		IconPos|=ICON_BEFORE_TEXT;
		IconPos&=~ICON_AFTER_TEXT;
	}
	else if  ((comboiconpos->getText())=="ICON_AFTER_TEXT")
	{
		IconPos|=ICON_AFTER_TEXT;
		IconPos&=~ICON_BEFORE_TEXT;
	}
	else if  ((comboiconpos->getText())=="ICON_ABOVE_TEXT")
	{
		  IconPos|=ICON_ABOVE_TEXT;
		  IconPos&=~ICON_BELOW_TEXT;
	}
	else if  ((comboiconpos->getText())=="ICON_BELOW_TEXT")
	{
		IconPos|=ICON_BELOW_TEXT;
		IconPos&=~ICON_ABOVE_TEXT;
	}
//	sample->setIconPosition(IconPos);
	return 1;
}

long GenWindow::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style; //=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	if ((comboframe->getText())=="FRAME_NONE")
	{
		style|=FRAME_NONE;
	}
	else if  ((comboframe->getText())=="FRAME_SUNKEN")
	{
		style|=FRAME_SUNKEN;
	}
	else if  ((comboframe->getText())=="FRAME_RAISED")
	 {
		style|=FRAME_RAISED;
	}
	else if  ((comboframe->getText())=="FRAME_THICK")
	 {
		style|=FRAME_THICK;
	}
	else if  ((comboframe->getText())=="FRAME_GROOVE")
	 {
		style|=FRAME_GROOVE;
	}
	else if  ((comboframe->getText())=="FRAME_RIDGE")
	 {
		style|=FRAME_RIDGE;
	}
	else if  ((comboframe->getText())=="FRAME_LINE")
	 {
		style|=FRAME_LINE;
	}
//	sample->setFrameStyle(style);
	return 1;
}

long GenWindow::onCmdAlign(FXObject*,FXSelector,void*)
{
	FXuint style; //=sample->getJustify();
	style=comboalign->getCurrentItem();
	if ((comboalign->getText())=="JUSTIFY_NORMAL")
	{
		style&=~JUSTIFY_LEFT;
		style|=JUSTIFY_NORMAL;
	}
	else if  ((comboalign->getText())=="JUSTIFY_CENTER_X")
	{
		style&=~JUSTIFY_HZ_APART;
	}
	else if  ((comboalign->getText())=="JUSTIFY_LEFT")
	 {
		style&=~JUSTIFY_HZ_APART;
		style|=JUSTIFY_LEFT;
	}
	else if  ((comboalign->getText())=="JUSTIFY_RIGHT")
	 {
		style&=~JUSTIFY_HZ_APART;
		style|=JUSTIFY_RIGHT;
	}
	else if  ((comboalign->getText())=="JUSTIFY_HZ_APART")
	 {
		style|=JUSTIFY_HZ_APART;
	}
	else if  ((comboalign->getText())=="JUSTIFY_CENTER_Y")
	 {
		style&=~JUSTIFY_VT_APART;
	}
	else if  ((comboalign->getText())=="JUSTIFY_TOP")
	 {
		style&=~JUSTIFY_VT_APART;
		style|=JUSTIFY_TOP;
	}
	else if  ((comboalign->getText())=="JUSTIFY_BOTTOM")
	 {
		style&=~JUSTIFY_VT_APART;
		style|=JUSTIFY_BOTTOM;
	}
//	sample->setJustify(style);
	return 1;
}

long GenWindow::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style; //=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	if ((combolayout->getText())=="LAYOUT_NORMAL")
	{
		style|=LAYOUT_NORMAL;
	}
	else if  ((combolayout->getText())=="LAYOUT_SIDE_TOP")
	{
		style|=LAYOUT_SIDE_TOP;
	}
	else if  ((combolayout->getText())=="LAYOUT_SIDE_BOTTOM")
	 {
		style|=LAYOUT_SIDE_BOTTOM;
	}
	else if  ((combolayout->getText())=="LAYOUT_SIDE_LEFT")
	 {
		style|=LAYOUT_SIDE_LEFT;
	}
	else if  ((combolayout->getText())=="LAYOUT_SIDE_RIGHT")
	 {
		style|=LAYOUT_SIDE_RIGHT;
	}
	else if  ((combolayout->getText())=="LAYOUT_FILL_COLUMN")
	 {
		style|=LAYOUT_FILL_COLUMN;
	}
	else if  ((combolayout->getText())=="LAYOUT_FILL_ROW")
	 {
		style|=LAYOUT_FILL_ROW;
	}
	else if  ((combolayout->getText())=="LAYOUT_LEFT")
	 {
		style|=LAYOUT_LEFT;
	}
	else if  ((combolayout->getText())=="LAYOUT_RIGHT")
	{
		style|=LAYOUT_RIGHT;
	}
	else if  ((combolayout->getText())=="LAYOUT_CENTER_X")
	 {
		style|=LAYOUT_CENTER_X;
	}
	else if  ((combolayout->getText())=="LAYOUT_FIX_X")
	 {
		style|=LAYOUT_FIX_X;
	}
	else if  ((combolayout->getText())=="LAYOUT_TOP")
	 {
		style|=LAYOUT_TOP;
	}
	else if  ((combolayout->getText())=="LAYOUT_BOTTOM")
	 {
		style|=LAYOUT_BOTTOM;
	}
	else if  ((combolayout->getText())=="LAYOUT_CENTER_Y")
	 {
		style|=LAYOUT_CENTER_Y;
	}
	else if  ((combolayout->getText())=="LAYOUT_FIX_Y")
	 {
		style|=LAYOUT_FIX_Y;
	}
	else if  ((combolayout->getText())=="LAYOUT_FIX_WIDTH")
	 {
		style|=LAYOUT_FIX_WIDTH;
	}
	else if  ((combolayout->getText())=="LAYOUT_FIX_HEIGHT")
	 {
		style|=LAYOUT_FIX_HEIGHT;
	}
	else if  ((combolayout->getText())=="LAYOUT_MIN_WIDTH")
	 {
		style|=LAYOUT_MIN_WIDTH;
	}
	else if  ((combolayout->getText())=="LAYOUT_MIN_HEIGHT")
	 {
		style|=LAYOUT_MIN_HEIGHT;
	}
	else if  ((combolayout->getText())=="LAYOUT_FILL_X")
	 {
		style|=LAYOUT_FILL_X;
	}
//	sample->setLayoutHints(style);
	 return 1;
}

long GenWindow::onCmdText(FXObject*,FXSelector,void*)
{
//	sample->setText(txtLabel->getText());
	return 1;
}

long GenWindow::onCmdToolTipMain(FXObject*,FXSelector,void*)
{
//	sample->setTipText(txtTooltip->getText());
	return 1;
}


long GenWindow::onCmdIcon(FXObject*,FXSelector,void*)
{
	if ((txtIcon->getText())=="") txtIcon->setText("NULL");
	return 1;
}

long GenWindow::onCmdWidth(FXObject*,FXSelector,void*)
{
//   sample->setWidth(spinw->getValue());
   return 1;
}

long GenWindow::onCmdHeight(FXObject*,FXSelector,void*)
{
//	sample->setHeight(spinh->getValue());
	return 1;
}

long GenWindow::onCmdPosX(FXObject*,FXSelector,void*)
{
//	sample->setX(spinPosX->getValue());
	return 1;
}

long GenWindow::onCmdPosY(FXObject*,FXSelector,void*)
{
//	sample->setY(spinh->getValue());
	return 1;
}

long GenWindow::onCmdTextColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	TextColor=colordlg->getRGBA();
//	sample->setTextColor(TextColor);
	return 1;
}

long GenWindow::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
//	sample->setBaseColor(BaseColor);
	return 1;
}

long GenWindow::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
//	sample->setBorderColor(BorderColor);
	return 1;
}

long GenWindow::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
//	sample->setHiliteColor(HiliteColor);
	return 1;
}

long GenWindow::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
//	sample->setShadowColor(ShadowColor);
	return 1;
}

long GenWindow::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
//	sample->setBackColor(BackColor);
	return 1;
}

long GenWindow::onCmdFont(FXObject*,FXSelector,void*)
{
	FXFontDialog fontdlg(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	myfont->getFontDesc(fontdesc);
	fontdlg.setFontSelection(fontdesc);
	if(fontdlg.execute())
	{
		fontdlg.getFontSelection(fontdesc);
		delete myfont;
		myfont=new FXFont(getApp(),fontdesc);
		myfont->create();
	}
//	sample->setFont(myfont);
	return 1;
}

long GenWindow::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdFontDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

/*******************************************************************************/
long GenWindow::onCmdName(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdVendor(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdClassName(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdVars(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdAddVar(FXObject*,FXSelector,void*)
{
	lstVars->appendItem(txtAddVar->getText(),NULL);
	txtAddVar->setText("");
	return 1;
}

long GenWindow::onCmdRemoveVar(FXObject*,FXSelector,void*)
{
	lstVars->removeItem(lstVars->getCurrentItem());
	return 1;
}

long GenWindow::onCmdEnums(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdAddEnum(FXObject*,FXSelector,void*)
{
	lstEnums->appendItem(txtAddEnum->getText(),NULL);
	txtAddEnum->setText("");
	return 1;
}

long GenWindow::onCmdRemoveEnum(FXObject*,FXSelector,void*)
{
	lstEnums->removeItem(lstEnums->getCurrentItem());
	return 1;
}

long GenWindow::onCmdMethods(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdAddMethod(FXObject*,FXSelector,void*)
{
	lstMethods->appendItem(txtAddMethod->getText(),NULL);
	txtAddMethod->setText("");
	return 1;
}

long GenWindow::onCmdRemoveMethod(FXObject*,FXSelector,void*)
{
	lstMethods->removeItem(lstMethods->getCurrentItem());
	return 1;
}

//   font  mainFont      
long GenWindow::onCmdFontMain(FXObject*,FXSelector,void*)
{
	FXFontDialog fontdlg(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	myfont->getFontDesc(fontdesc);
	fontdlg.setFontSelection(fontdesc);
	if(fontdlg.execute())
	{
		fontdlg.getFontSelection(fontdesc);
		delete myfont;
		myfont=new FXFont(getApp(),fontdesc);
		myfont->create();
	}
	return 1;
}

long GenWindow::onCmdStatusBar(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdToolBar(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdToolBox(FXObject*,FXSelector,void*)
{
	return 1;
}


long GenWindow::onCmdToolTip(FXObject*,FXSelector,void*)
{
	return 1;
}

long GenWindow::onCmdMainRes(FXObject*,FXSelector,void*)
{             FXString textMain;
	FXString* SumResM;
	FXString stdVarStr;
	FXString strFont;
	FXString ClassStr;
	FXString VarStr;
	FXString EnumStr;
	FXString MethodStr;
	FXString MapStr;
	FXString FirstMapLine;
	FXString ImpStr;
	FXString LastImpStr;
	FXString CreateStr;
	FXString MethodImp;
	FXString FormStr="// Form begins here\n";
	FXString strStatusBar;
	FXString strToolBar;
	FXString strTips;
	FXString strIncludes;
	FXString TotalM;
	
	if ((chkStatusBar->getCheck())==TRUE)
	{
		strStatusBar="statusbar=new FXStatusbar(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|STATUSBAR_WITH_DRAGCORNER);\n";
		stdVarStr="\t\tFXFont* mainFont;\n\t\tFXStatusbar* statusbar;\n"; 	} 	else 	{
		strStatusBar="";
		stdVarStr="\t\tFXFont* mainFont;\n";
	}
	if ((chkToolBar->getCheck())==TRUE)
	{
		strToolBar="toolbar=new FXToolbar(this,LAYOUT_SIDE_TOP|LAYOUT_FIX_X|PACK_UNIFORM_WIDTH|PACK_UNIFORM_HEIGHT|FRAME_RAISED);\n";
	}
	if ((chkToolTip->getCheck())==TRUE)
	{	
		strTips="FXTooltip* tooltip= new FXTooltip(getApp());\ntooltip->setFont(mainFont);\n";
	}

	strFont="mainFont=new FXFont(getApp(),"+
		ec+myfont->getName()+ec+","+
		FXStringVal((myfont->getSize())/10)+");\n"+strStatusBar+"\n";
	FXString Cname=txtClassName->getText();
	for (int i=0; i<lstVars->getNumItems(); i++)
		VarStr=VarStr+"\t\t"+lstVars->getItemText(i)+";\n";
	VarStr=stdVarStr+VarStr;	
	EnumStr="\t\t"+lstEnums->getItemText(0)+"=FXMainWindow::ID_LAST,\n";
	for (int i=1; i<lstEnums->getNumItems(); i++)
		EnumStr=EnumStr+"\t\t"+lstEnums->getItemText(i)+",\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MethodStr=MethodStr+"\t\t"+"long "+ lstMethods->getItemText(i)+"(FXObject*,FXSelector,void*);\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MapStr=MapStr+"FXMAPFUNC(SEL_COMMAND,"+Cname+"::"+lstEnums->getItemText(i)+","+Cname+"::"+lstMethods->getItemText(i)+"),\n";
	ClassStr="class "+ Cname+": public "+cmbClassTypes->getText()+"\n"+
		"{\n"+"	FXDECLARE("+Cname+")\n"+
		"\tprotected:\n"+
		VarStr+
		"\tprotected:\n"+"\t"+
		Cname+"(){}\n"+
		"\tpublic:\n"+
		"\tenum {\n"+EnumStr+
		"};\n"+
		"\tpublic:\n"+MethodStr+
		"\tpublic:\n\t"+Cname+"(FXApp* a);\n"+"\tvoid create();\n};\n\n";
	FirstMapLine="FXDEFMAP("+Cname+") "+Cname+"Map[]={\n";	
	ImpStr="FXIMPLEMENT("+Cname+",FXMainWindow,"+Cname+"Map,ARRAYNUMBER("+Cname+"Map))\n";
	LastImpStr=Cname+"::"+Cname+"(FXApp* a):FXMainWindow(a,"+ec+txtAppName->getText()+ec+",NULL,NULL,DECOR_ALL,1,1,500,400)\n{\n";
	textMain="int main(int argc,char *argv[])\n{\n\tFXApp application("+
			    ec+txtAppName->getText()+ec+","+
			    ec+txtAppVendor->getText()+ec+
			    ");\n	application.init(argc,argv);\n\tnew "+
			    txtClassName->getText()+
			    "(&application);\n\tapplication.create();\n\treturn application.run();\n}";
	CreateStr="\nvoid "+Cname+"::create()\n"+"{\n\tFXMainWindow::create();\n\tshow(PLACEMENT_SCREEN);\n}\n\n";
	for (int i=0; i<lstMethods->getNumItems(); i++)
		MethodImp=MethodImp+"long "+Cname+"::"+lstMethods->getItemText(i)+"(FXObject*,FXSelector,void*)\n{\n\treturn 1;\n}\n\n";		

	strIncludes="#include "+ec+"/usr/local/include/fox/fx.h"+ec+"\n\n";
	TotalM=strIncludes+ClassStr+FirstMapLine+MapStr+"};\n"+ImpStr+LastImpStr+FormStr+strFont+strToolBar+strTips+"}\n"+CreateStr+MethodImp+textMain;
	
	SumResM=&TotalM;
	mtxtCode->insertText(mtxtCode->getCursorPos(),SumResM->text(),SumResM->size()-1, FALSE);
	return 1;
}

long GenWindow::onCmdVarType(FXObject*,FXSelector,void*)
{
	txtAddVar->setText(cmbVarTypes->getText());
	return 1;
}

long GenWindow::onCmdClassType(FXObject*,FXSelector,void*)
{
	return 1;
}

// Start the whole thing
int main(int argc,char *argv[]){

  // Make application
  FXApp application("Generator","Anastasios Sarris");

  // Open display
  application.init(argc,argv);

  // Make window
  new GenWindow(&application);

  // Create app
  application.create();

  // Run
  return application.run();
  }

